#!/usr/bin/env python
import subprocess, string
import os, os.path
import sys, math
#MegaCli64 fwtermlog dsply a0 nolog | grep Sense: | head
#need to provide alert in case of offline PD...in lsi

###
### To Do:
### (1) running under case that DB is live but not working correctly
### (2) don't run it again if the previous one is pending in ps aux
### (3) Resolve duplicate when UB without recognition of RAW Size.  (2/2/2015 by using scsi address: see get_lsi_devices()
### (4) Accomodate multi-raid controller solution.... using aall instead of a0

###
### testOn menu
###   "LSIRawSizeTest": When one drive becomes UB with 0 GB in Raw Size, duplicate drive happens in LSI controller.
###   "SWRAID" : SW RAID TESTING
###   "LSIBGI" : To test Andy's snmp parsing tool
###   "raidInfo" : To test randInfo
abs_path = os.path.abspath(sys.argv[0])
basename = os.path.basename(sys.argv[0])
dirname = abs_path.replace(basename, "")

_wgetPath = "/usr/bin/wget"
_ftpPath = "ftp://ftp.unitrends.com/utilities" 
_ftpSite = "ftp.unitrends.com"
if not os.path.exists("%s/diskmon" % dirname):
   if dirname == "/root/": # only if supporting case
      import commands
      lines = commands.getoutput("%s -N %s/%s.tgz 2>&1 " %(_wgetPath, _ftpPath, basename)).splitlines()
   if os.path.exists("%s.tgz" % basename):  # only when no diskmon and tgz file available
      os.system("/bin/tar zxf %s.tgz" % basename) 

if not "%s/diskmon/lib" % dirname in sys.path:
   sys.path.insert(0,"%s/diskmon/lib" % dirname) # always with regard to parent script
if not "/usr/bp/lib/monitoring" in sys.path:
   sys.path.append("/usr/bp/lib/monitoring")

from util      import *   # include config << bpdb as well 
(opts, args)=get_parser(sys.argv)

from appliance import *
from device    import *
from logger    import *
from disk      import *
from raid      import *
from checklist import *

#########################################################
def main():

   # path check and crontab
   if not init():   return
   #####
   CheckDPU()

   #### major starts
   dpu = DPU() # full scan to retrive smart information

   if "Unk" in dpu.appliance.name:
      print "[WARNING] This appliance (%s) is not supported by this script" % dpu.modelNo
      return
   elif "UEB" in dpu.appliance.name or "Metal" in dpu.appliance.name:
      anaUEB()
      return

   #if not CONFIG.confirm:  #Now it is required even with confirm for Andy's parsing
   dpu.printout()
   postDocumentation(dpu.disks) #diskConfig.ini gets updated in DPU.GetMdRaids();

   if (CONFIG.now.hour==1 and CONFIG.now.minute <15) or CONFIG.detailSMART:    # This runs 1AM every day or Interactive mode
      dailySMARTLOG(dpu.disks)
   
   dpu.printLayout() # only work for 943
   dpu.doAlert()

   if CONFIG.anaLSILog:
      dpu.anaLSILog()

   io_error_check(dpu.appliance)
   xfs_check(dpu.appliance)

   return

####################
def get_age_of_file(filename):
   now = CONFIG.epochNow
   if not os.path.exists(filename):
      return now
   else:
      return now - os.path.getmtime(filename)


def get_lsi_devices(): # ready for multi-raid controller

   #Keyword RAID is not enough to bring SCSI storage controller
   #03:00.0 SCSI storage controller: LSI Logic / Symbios Logic MegaRAID SAS 8208ELP/8208ELP (rev 08)
   #06:00.0 RAID bus controller: LSI Logic / Symbios Logic MegaRAID SAS 2108 [Liberator] (rev 05)
   
   lines =get_printout("/sbin/lspci | grep 'RAID bus controller'")
   raid_scsi_addrs=[]
   for line in lines:  raid_scsi_addrs.append(line.split()[0])

   LSI_devices=[]
   for scsi in CONFIG.scsi_devices:
      if not scsi.vendor in ["LSI","SMC"]: continue
      for i in range(len(raid_scsi_addrs)):
         raid_scsi_addr=raid_scsi_addrs[i]
         if raid_scsi_addr in scsi.path:
            LSI_devices.append((scsi.device, i, scsi.vdNumber)) # deviceShort, adapter number, vd number
   return LSI_devices 

#################class DPU ##########################
class DPU:
   """Representing Disk"""
   def __init__(self):

      self.assetTag = CONFIG.assetTag
      self.modelNo  = CONFIG.modelNo

      # Version 4.0.2-1.CentOS   : 620-300-16727-GE
      words = self.assetTag.split("-")

      # UEB Asset: eg. 60b099ac-7e7e-42dd-bb96-bda073927077
      if len(words) >3:
         #if len(words[3])>5 :
         oshosts =[]
         self.appliance = Appliance("UEB",  0, False,  0, 0,  256, "", oshosts)
         return
      elif "Metal" in words[0]:
         oshosts =[]
         self.appliance = Appliance("Metal",  0, False,  0, 0,  256, "", oshosts)
         return
         
      self.version = CONFIG.version
      self.appliance = getApplianceDetail(self.modelNo)
      self.disks     = []
      self.IsThereLSIDisk   = (self.appliance.controller == "LSI") # to be used for RAID
      self.LSI_devices=get_lsi_devices()
      self.IsThere3wareDisk = (self.appliance.controller == "3ware") # to be used for RAID

      self.MegaCliLdPdOutput =[]
      #self.MegaCliLdInfoOutput =[]
      self.MegaCliPdListOutput =[]
      self.MegaCliRaids = []
      self.IsCacheCadeSetup = False

      self.prStatus =""
      self.tw_cli_Status=""
      self.fwVer = ""
      self.controllerName = ""
      #self.LSIRaidDrives=[]
      if self.appliance.controller == "LSI":
         if get_age_of_file(CONFIG.lsiLogfile) > 2*24*3600:  # 2days * 24 hours * 3600 secs         
            os.system("%s -AdpEventLog -GetEvents -info -f %s -a0 -NoLog > /dev/null 2>&1" % (CONFIG.MegaCli64_Path, CONFIG.lsiLogfile))
         
         self.MegaCliAdpPrOutput  = get_printout("%s -AdpPr -Info -a0 -NoLog" % CONFIG.MegaCli64_Path)
         self.MegaCliLdPdOutput   = get_printout("%s -LdPdInfo -a0 -NoLog" % CONFIG.MegaCli64_Path)
         lsiCommand ="%s -PdList -a0 -NoLog | " % CONFIG.MegaCli64_Path
         lsiCommand+="grep -E 'Enclosure Device ID|Slot Number|Enclosure position|Device Id|Firmware state|Raw Size|Inquiry|PD Type|DiskGroup'"
         self.MegaCliPdListOutput = get_printout(lsiCommand)

         lines = get_printout("%s -AdpAllInfo -a0 -NoLog | grep -E 'Product Name|FW Version'" % CONFIG.MegaCli64_Path) 
         if len(lines)>0:
            words = lines[0].split()
            for i in range(len(words)):
               if i>2: self.controllerName += words[i] + " "
            self.fwVer = lines[1].split()[3]

         for i in range(len(self.MegaCliAdpPrOutput)):
            line = self.MegaCliAdpPrOutput[i]
            words = line.split(":")
            if "Current State" == words[0]:
               self.prStatus = words[1].strip()
               CONFIG.prStatus = self.prStatus
         
         bgiProgress =""
         for i in range(len(self.MegaCliLdPdOutput)):
            line = self.MegaCliLdPdOutput[i]
            words = line.split(":")
            segs = line.split()
            if not len(segs): continue
            if "Virtual Drive" in words[0] and not "Type" in words[0]:
               vdname = "%s: %d" % (words[0],int(words[1].split()[0]))
               vdNumber =int(words[1].split()[0]) ##***
            if "Size" in segs[0] and ":" in segs[1]:
               theSize = words[1].strip()
               theTB = int(float(segs[2]) + 0.5)
               if segs[3] == "GB":
                  theTB= int(float(segs[2])/1024. + 0.5)
            if "State" in segs[0] and ":" in segs[1]:
               raidState = words[1].strip()
            if "RAID Level          " in words[0] or  "State\t\t" in words[0]:
               raidLevel = words[1].strip()
            if "Number Of Drives per span" in words[0] or "Number Of Drives    " in words[0]:
               numberOfDisk = int( words[1] )
            if "Span Depth          " in words[0]:
               depth = int(words[1])
            if "Current Cache Policy" in words[0]:
               cachePolicy = words[1]
            if "Background Initialization" in words[0]:
               bgiProgress = (segs[3])[:-1]

            if "Span:" == segs[0] and  "Number of PDs" in line:
               spanNumber =int(segs[1])
               nPDs       =int(segs[6])
               
            if "Is VD Cached" in words[0]:
               isVDCached=False
               if "Yes" in words[1]:
                  isVDCached=True

               theDevice=""
               for device in self.LSI_devices:
                  if 0==device[1] and int(vdname[-1:])==device[2]: theDevice=device[0]
                  
               self.MegaCliRaids.append(RAID_LSI(vdname, theDevice, numberOfDisk, theSize, raidState, raidLevel, cachePolicy, depth, isVDCached, bgiProgress))
               bgiProgress =""
            if "Target Id of the Associated LDs" in words[0]:  #CacheCade
               line = self.MegaCliLdPdOutput[i+2]
               words = line.split(":")
               if "Current Cache Policy" in words[0]:
                  cachePolicy = words[1]
               theDevice=""
               self.MegaCliRaids.append(RAID_LSI(vdname, theDevice, 1           , theSize, raidState, raidLevel, cachePolicy, 1))
               
            if "CacheCade Virtual Drive" in line:
               self.IsCacheCadeSetup = True

            if "PD:" == segs[0] and "Information" == segs[2]:
               pdNumber=int(segs[1])
            #if "Drive's position:" in line:
            #   diskGroup =int( (segs[3])[:-1] )
            #   span      =int( (segs[5])[:-1] )
            #   arm       =int( segs[7] )
            #   diskPosition=(diskGroup, span, arm)
            #   isCacheCadeDrive =False
            #   if "CacheCade" in vdname: isCacheCadeDrive=True 
            #   self.LSIRaidDrives.append( (vdname, theDevice, spanNumber, nPDs, isCacheCadeDrive, diskPosition) )
               #print vdNumber, spanNumber, nPDs, isCacheCadeDrive, diskGroup, span, arm
               
         ######      
         cnt = 0  # to be used...
         thePDType=''
         diskGroup,span,arm,diskPosition=-9,-9,-9,(-9,-9,-9)
         for line in self.MegaCliPdListOutput:
            words = line.split()
            #Drive's postion: DiskGroup: 1, Span: 0, Arm: 0
            if "Enclosure" in words[0] and "Device" in words[1]:
               theEncId  =words[len(words)-1]
            if "Slot"  in words[0]:
               theSlotNo =int(words[len(words)-1])
            if "Drive's position:" in line:
               diskGroup =int( (words[3])[:-1] )
               span      =int( (words[5])[:-1] )
               arm       =int( words[7] )
               diskPosition=(diskGroup, span, arm)
            if "Enclosure" in words[0] and "position" in words[1]:
               theEncPosition = words[len(words)-1]
            if "Raw"  in words[0]:
               theRawSize = float(words[2].strip())
               if words[3]=="TB":
                  theRawSize *= 1024
            if "Device"  in words[0]:
               theDeviceId = int(words[len(words)-1])
            if "PD Type:" in line:
               thePDType = words[len(words)-1]
            if "Firmware"  in words[0]:
               theStatus = words[len(words)-1]
               if "Unconfigure" in words[len(words)-3]: # for what??  Firmware state: Unconfigured(bad) #status = "Unconfigured(good)"
                  theStatus = words[len(words)-3]

            if "Inquiry" in words[0]:
               segs=line.split(":")
               theInquiryData = segs[1]
               if theStatus == "JBOD": continue
               if CONFIG.testOn == "LSIRawSizeTest":
                  if theSlotNo==4:
                     theStatus = "Unconfigured(Bad)"
                     theRawSize= 0.

               deviceName,theVdname,isVDCached,raidIdx="","",False,-9
               for i in range(len(self.MegaCliRaids)):
                  raid = self.MegaCliRaids[i]
                  if math.fabs(theRawSize/raid.diskSize-1) > 0.1: continue
                  raidIdx=i

               if raidIdx>=0:
                  theRaid = self.MegaCliRaids[raidIdx]
                  theVdname = theRaid.name
                  isVDCached = theRaid.isVDCached
                  deviceName = theRaid.device

               if ("CacheCade" in theVdname or raidIdx<0) and len(self.LSI_devices): # Need to assign any LSI device name to pull out SMART information
                 deviceName=""
                 for lsi_device in self.LSI_devices:
                    if "/dev/sd" in lsi_device[0]:
                       deviceName = lsi_device[0]
                       break
               lsidisk = Disk_LSI(self.appliance, deviceName, theDeviceId, theSlotNo, theStatus, theEncId, theVdname, \
                                     isVDCached, self.IsCacheCadeSetup, raidIdx, thePDType, diskGroup, span, arm)
               diskGroup,span,arm,diskPosition=-9,-9,-9,(-9,-9,-9)
               self.disks.append(lsidisk)
               cnt += 1

               
      self.tw_cli_output =[]
      if "3ware" in self.appliance.controller:
         self.tw_cli_output = get_printout("%s info | grep c" % CONFIG.tw_cliPath)[0]
         if not os.path.exists(CONFIG.twcliLogfile):
            os.system("echo > %s" % CONFIG.twcliLogfile)

         #if get_age_of_file(CONFIG.twcliLogfile) > 1*1*3600:  # every hour
         os.system("%s show alarms | grep -v ^$ > /tmp/twcli.show.alarms.tmp.log" % (CONFIG.tw_cliPath))
         os.system("/usr/bin/diff %s /tmp/twcli.show.alarms.tmp.log | grep '>' > /tmp/twcli.diff.log" % CONFIG.twcliLogfile)
         os.system("sed -i 's/> //g' /tmp/twcli.diff.log; cat /tmp/twcli.diff.log >> %s" % CONFIG.twcliLogfile)
         
         name = self.tw_cli_output.split()[0]
         lines = get_printout("%s info %s | grep RAID" % (CONFIG.tw_cliPath, name) )
         if len(lines)>0:
            words = lines[0].split()
            self.tw_cli_Status = words[2]
            CONFIG.tw_cli_Status = self.tw_cli_Status
            
         command ="%s /%s show firmware | grep 'Firmware'" % (CONFIG.tw_cliPath, name)
         lines = get_printout(command)
         if len(lines)>0:
            words = lines[0].split()
            for i in range(len(words)):
               if i>2:   self.fwVer += words[i] + " "
         lines = get_printout("%s /%s show model | grep 'Model'" % (CONFIG.tw_cliPath, name) )
         if len(lines)>0:
            words = lines[0].split()
            for i in range(len(words)):
               if i>2:   self.controllerName += words[i] + " "
               
      self.raids     = []
      ##############
      self.GetDisks()  # In case of LSI, duplicate disks are resolved here
      self.GetDiskDetails()
      ### Time to generate LSI Controller Log File if needed.

      if os.path.exists("/proc/mdstat"):
         if int(get_first_word("cat /proc/mdstat | /usr/bin/wc -l")) >2:
            self.GetMdRaids()

      if self.appliance.controller == "LSI":
         self.GetLSIRaids()
      elif self.appliance.controller == "3ware":   
         self.Get3wareRaids()

      isupdated = self.CheckConfigFile()
      #if isupdated:
      #   config = ConfigParser.ConfigParser()
      #   if os.path.exists(CONFIG.configFile):
      #      config.read(CONFIG.configFile)
      #   self.diskConfig = config   
      


### end of __init__

 
   ################## GetMdRaids ##########
   def GetMdRaids(self):   # MD RAID
      raid = RAID_OS(self.appliance)
      if CONFIG.verbose=="GetMdRaids":
         print "WP@disk_monitoring_logger.py:GetMdRaids raid.devices ", raid.devices
         print "WP@disk_monitoring_logger.py:GetMdRaids self.disks ", self.disks

      for disk in self.disks:
         raid.disks.append(disk)
         for device in raid.devices:
            if not device in disk.device: continue  # without this, there could be more drives that RAID associates 
            if disk.rscDrive:
               raid.reallocDisks.append(disk)
            if disk.serDrive:
               raid.serDisks.append(disk)
            if disk.pndDrive:
               thelogfile = "%s/%s.%s.dat" % (CONFIG.directory_paths[CONFIG.ibase], disk.smart.modelName, disk.smart.serialNumber)
               raid.pendingDisks.append(disk)
                     
      for disk in raid.reallocDisks:
         #print "reallocDisk", disk      
         if not disk in raid.problemDisks:
            raid.problemDisks.append(disk)
      for disk in raid.pendingDisks:
         #print "pendingDisk", disk      
         if not disk in raid.problemDisks:
            raid.problemDisks.append(disk)
         if not disk in raid.needDisks:
            raid.needDisks.append(disk)
      for disk in raid.serDisks:
         #print "serpendingDisk", disk      
         if not disk in raid.problemDisks:
            raid.problemDisks.append(disk)
      for disk in raid.degradedDisks:
         #print "degradedDisk", disk      
         if not disk in raid.needDisks:
            raid.needDisks.append(disk)

      self.raids.append(raid)

   ##################
   def GetLSIRaids(self):   # LSI RAID
      
      if len(self.MegaCliRaids):
         for raid in self.MegaCliRaids:
            self.raids.append(raid)
               
      raids =[]
      #print "N Disks", len(self.disks)
      for raid in self.raids:
         if isinstance(raid, RAID_LSI):
            for disk in self.disks:
               if not isinstance(disk, Disk_LSI): continue
               if not raid.VD_Id == disk.VD_Id: continue
               if disk.statusInitial != "o":
                  raid.degradedDisks.append(disk)
                  if "R" in disk.statusInitial:  #disk.statusInitial == "R" noticed *R case.... 104 pending sector... 
                     theCommand = "%s -pdrbld -showprog -physdrv%s -a0 -NoLog | grep Rebuild" \
                         % (CONFIG.MegaCli64_Path,disk.braket)
                     outputs = get_printout(theCommand)
                     if len(outputs) > 0:
                        output = outputs[0]
                        progress = find_word_wrt_key("%", output)
                        raid.printMessage = raid.message + " (Rebuild Progress %s)" % progress
                        raid.progressMessage = "(Rebuild Progress %s)" % progress
               else:
                  if disk.rscDrive:
                     raid.reallocDisks.append(disk)
                  # SAS drive is not considered in pending sector   
                  if disk.pndDrive and not disk.SAS:
                     # meaning not fixed by controller auto-veryfy OR is controller already verified
                     # OR run by interactively
                     if self.didControllerVerify(disk) or CONFIG.runDirname != "/usr/bp/bin/": 
                        raid.pendingDisks.append(disk)
                  if disk.serDrive:
                     raid.serDisks.append(disk)
               raid.disks.append(disk)

         for disk in raid.reallocDisks:
            if not disk in raid.problemDisks:
               raid.problemDisks.append(disk)
         for disk in raid.pendingDisks:
            if not disk in raid.problemDisks:
               # SAS drive is not considered in pending sector
               if not disk.SAS:
                  raid.problemDisks.append(disk)
         for disk in raid.serDisks:
            if not disk in raid.problemDisks:
               raid.problemDisks.append(disk)

               
         raid.nmiss = len(raid.degradedDisks)
         raid.nmiss += raid.ndisk-len(raid.disks)
         raids.append(raid)
         if CONFIG.verbose=="GetLSIRaids":
            print "NrscDrive, NpendingDisks, NserDisks", len(raid.reallocDisks), len(raid.pendingDisks), len(raid.serDisks), raid.nmiss, raid.ndisk, len(raid.disks)
            
      self.raids = raids
      #should be filled before         
      #if self.IsThere3wareDisk:

   def Get3wareRaids(self):   # 3ware RAID
      raids =[]         
      for raid in self.raids:
         if isinstance(raid, RAID_3ware):
            for disk in self.disks:
               if not isinstance(disk, Disk_3ware): continue
               #print "WP:: degradedDisk " + disk.statusInitial, CONFIG.maxPendingSectorAF
               if disk.statusInitial != "o":
                  raid.degradedDisks.append(disk)
               else:
                  if disk.rscDrive:
                     raid.reallocDisks.append(disk)
                  if disk.serDrive:
                     raid.serDisks.append(disk)
                  if disk.pndDrive:
                     # meaning not fixed by controller auto-veryfy OR is controller already verified
                     # OR run by interactively
                     if self.didControllerVerify(disk) or CONFIG.runDirname != "/usr/bp/bin/": 
                        raid.pendingDisks.append(disk)

         for disk in raid.reallocDisks:
            if not disk in raid.problemDisks:
               raid.problemDisks.append(disk)
         for disk in raid.pendingDisks:
            if not disk in raid.problemDisks:
               raid.problemDisks.append(disk)
         for disk in raid.serDisks:
            if not disk in raid.problemDisks:
               raid.problemDisks.append(disk)
         raids.append(raid)
         
      self.raids = raids

   def didControllerVerify(self, disk):

      diskHealthFilename = "%s/%s.%s.dat" \
          % (CONFIG.directory_paths[CONFIG.ibase], disk.smart.modelName, disk.smart.serialNumber)
      if not os.path.exists(diskHealthFilename):
         return False

      import datetime
      now = CONFIG.now
      dayoffset = 0
      for i in range(0,7):
         then = now - datetime.timedelta(hours = 24*i)
         if then.strftime("%a") == "Sat":
            dayoffset = i
            break

      lastHealthyDiskHr = get_nth_word("/usr/bin/tac %s/%s.%s.dat | grep '0     0' | /usr/bin/head -1" \
                                          % (CONFIG.directory_paths[CONFIG.ibase], disk.smart.modelName, disk.smart.serialNumber), 2)
      currentDiskHr     = get_nth_word("/usr/bin/tail -1 %s/%s.%s.dat" \
                                          % (CONFIG.directory_paths[CONFIG.ibase], disk.smart.modelName, disk.smart.serialNumber), 2)
      if len(lastHealthyDiskHr)==0:
         lastHealthyDiskHr = 0
      hoursSinceLastHealth = int(currentDiskHr) - int(lastHealthyDiskHr)
      if CONFIG.verbose == "didControllerVerify":
         print diskHealthFilename
         print "hoursSinceLastHealth, curDiskHr, lastHealthyDiskHr  ", hoursSinceLastHealth, int(currentDiskHr), int(lastHealthyDiskHr)
         
      if isinstance(disk, Disk_3ware):
         if self.tw_cli_Status == "VERIFYING": return False  # verify is ongoing and need to wait
         hoursSinceLastSat = now.hour + dayoffset*24
         if CONFIG.verbose == "didControllerVerify":
            print "hoursSinceLastHealth, hoursSinceLastSat", hoursSinceLastHealth, hoursSinceLastSat 
         if hoursSinceLastHealth > (hoursSinceLastSat + 24):  # 24 hours for extra room
            return True
      elif isinstance(disk, Disk_LSI):
         if CONFIG.verbose == "didControllerVerify":
            print "entering Disk_LSI"
         if self.prStatus == "Active": return False  # read patrol is ongoing and need to wait 
         lines = get_printout("grep -i 'patrol read complete' %s -B 5 | /usr/bin/tail -6 | /usr/bin/head -1" % CONFIG.lsiLogfile)
         if not len(lines): return False
         line = lines[0]
         words = line.split()  #['Time:', 'Sat', 'Sep', '27', '03:00:01', '2014']
         segs = words[4].split(":")
         month=get_digit_from_month(words[2])
         datetime=datetime.datetime(int(words[5]), month, int(words[3]), int(segs[0]), int(segs[1]), int(segs[2]))
         if CONFIG.verbose == "didControllerVerify":
            print "last patrol read time: ", words

         hoursSinceLastPR = (CONFIG.epochNow - float(datetime.strftime('%s'))) / 3600
         hoursSinceLastPR = int ( hoursSinceLastPR + 0.5 )
         if hoursSinceLastHealth > (hoursSinceLastPR + 12): # 12 hours for extra room
            return True

      return False
      #should be filled before         
      #if self.IsThere3wareDisk:

   def GetDisks_3Ware(self, vendor0, deviceName="/dev/sdX/"):
      allDisks =[]
      diskStatus = []
      diskStatusAtUnit = []
      unitnames = []
      raidInfos = get_printout("%s info | /usr/bin/tail -2 | /usr/bin/head -1" % CONFIG.tw_cliPath )[0].split()
      # Ctl   Model        (V)Ports  Drives   Units   NotOpt  RRate   VRate  BBU
      # c0    9650SE-12ML  12        12       1       0       5       1      -
      # c0    9650SE-12ML  12        11       1       1       5       1      -
      # c0    9650SE-12ML  12        12       1       1       1       1      - 7 drive with pending...
      raidControl = raidInfos[0]
      unitInfos = get_printout("%s info %s | grep RAID"% (CONFIG.tw_cliPath, raidControl))[0].split() # one RAID
      unitname = unitInfos[0].strip()
      RaidStatus =unitInfos[2].strip()
      RaidLevel = unitInfos[1].strip()
      #ndrives + nNotOpt : this works even when degraded
      subunits = []
      nOKDrives =0
      nDGDrives =0
      for line in get_printout("%s info %s %s| grep %s-" % (CONFIG.tw_cliPath, raidControl, unitname, unitname)):
         words = line.split()
         ue = UnitElement()
         ue.unitIndex = words[0]
         ue.status = words[2]
         ue.vport  = words[5]
         if "GE" in CONFIG.assetTag and ue.status == "NOT-PRESENT":
            continue
         #if ue.status == "OK":
         if ue.status == "OK" or ue.status == "WARNING":
            nOKDrives += 1
         else:  # if ue.status == "DEGRADED": there is "-"
            nDGDrives += 1
         subunits.append(ue)
         
      self.raids.append(RAID_3ware(raidControl, int(raidInfos[2]), RaidStatus, 1, int(raidInfos[5]), RaidLevel, subunits  )) 

      for line in get_printout("%s info %s | grep 'p' | grep -v Status" % (CONFIG.tw_cliPath, raidControl)):
         words = line.split()
         if "GE" in CONFIG.assetTag and words[1] == "NOT-PRESENT": continue
         vport = words[0]
         allDisks.append(vport)
         statusToPut = words[1]
         unitnames.append(words[2].strip())
         if "OK" not in words[1]:
            statusToPut = statusToPut + "_" + RaidStatus
         # print statusToPut 
         diskStatus.append(statusToPut)

         found = False
         theStatus = ""
         for ue in subunits:
            if ue.vport == vport:
               found = True
               theStatus = ue.status
               break
         if not found:
            lines = get_printout("%s info %s | grep SINGLE"% (CONFIG.tw_cliPath, raidControl))
            if len(lines)>0:
               singleUnitInfos = lines[0].split() 
               theStatus = singleUnitInfos[2].strip()
               #unitname = singleUnitInfos[0].strip()
            else:   
               diskStatusAtUnit.append("NA")
         else:
            diskStatusAtUnit.append(theStatus)

      theFirstIdx = int(allDisks[0][1:])
      if theFirstIdx < 3:
         theFirstIdx = 0
      else:
         theFirstIdx = 8
            
      #for nth in range(theFirstIdx, theFirstIdx + self.raids[len(self.raids)-1].ndisk): #nth 0 to ndisk-1

      twcli_info_lines=[]
      if "U" in self.appliance.name or "GE" in CONFIG.assetTag: # for 2U and 3U                                             
         twcli_info_lines=get_printout("%s info | grep c" % CONFIG.tw_cliPath)
         
      if "GE" in CONFIG.assetTag: # for 620-300-16727-GE
         if len(allDisks) == self.appliance.ndisk+1 or len(allDisks) == self.appliance.ndisk:
            for dcnt in range(len(allDisks)):
               status=diskStatus[dcnt]
               statusAtUnit=diskStatusAtUnit[dcnt]
               unitname = unitnames[dcnt]
               self.IsThere3wareDisk = True
               nth = int(allDisks[dcnt][1:])
               slotNo=nth
               theDisk = Disk_3ware(self.appliance, deviceName, nth, slotNo,
                                    vendor0, status, statusAtUnit, RaidStatus, raidControl, unitname, twcli_info_lines) # c0 u0
               self.disks.append(theDisk)
      else:
         if self.appliance.controller=="3ware_9750":
            ulines =get_printout("%s info %s %s | grep 'p' | grep -v Status" % (CONFIG.tw_cliPath, raidControl, unitname))

            for line in get_printout("%s info %s | grep 'p' | grep -v Status" % (CONFIG.tw_cliPath, raidControl)):
               #p8    OK             u0   2.73 TB   SATA  -   /c0/e0/slt0  ST3000DM001-1CH166
               words=line.split()
               status=words[1]
               unitname=words[2]
               slotNo=(words[7]).split("slt")[1]
               if "?" in slotNo:
                  slotNo=-1
               else:
                  #p18   OK             u0   2.73 TB   SATA  -   /c10/e0/slt10ST3000DM001-1CH166
                  if len(slotNo)>2: slotNo=slotNo[0:2]
                  slotNo=int(slotNo)

               nth=int(words[0].split("p")[1])  # nth is for smartctl number, virtual port
               statusAtUnit,theUnitLine='',''
               for uline in ulines:
                  if "%s-%s" % (unitname,slotNo) in uline:
                     theUnitLine=uline
                     break
               if len(theUnitLine):   statusAtUnit=theUnitLine.split()[2]
               self.IsThere3wareDisk = True
               theDisk = Disk_3ware(self.appliance, deviceName, nth, slotNo,
                                    vendor0, status, statusAtUnit, RaidStatus, raidControl, unitname, twcli_info_lines) # c0 u0
               self.disks.append(theDisk)
            
         else:   
            for nth in range(theFirstIdx, theFirstIdx + self.appliance.ndisk): #nth 0 to ndisk-1
               status = "TBD" #following megaraid convention
               statusAtUnit = "TBD"
               dcnt =0
               for okDisk in allDisks:
                  if "p%d"% nth in okDisk:
                     status=diskStatus[dcnt]
                     statusAtUnit=diskStatusAtUnit[dcnt]
                     unitname = unitnames[dcnt]
                     break
                  else:
                     dcnt = dcnt + 1
               self.IsThere3wareDisk = True
               slotNo=nth
               theDisk = Disk_3ware(self.appliance, deviceName, nth, slotNo,
                                    vendor0, status, statusAtUnit, RaidStatus, raidControl, unitname, twcli_info_lines) # c0 u0
               self.disks.append(theDisk)
            
      return

   def GetDisks(self):
      isScanDoneForUs = False
      isDoneForHWRaid = False
      lsiDevices = []

      flashcacheDevice=""
      if CONFIG.CentOS_version==6:
         for line in get_printout("/sbin/dmsetup table database"):
            if "ssd" in line:  flashcacheDevice=line.split("(")[1].split(")")[0]
              
      # This is for IDE drive: lsscsi can't pick them up      
      for line in get_printout("ls -l /sys/block/*d*/device"):
         #/sys/block/hda/device -> ../../devices/ide0/0.0
         if not "hda" in line: continue
         deviceShort,hostNumber = "hda",-1
         command = "/sbin/fdisk -l /dev/%s" % deviceShort
         if not len(get_printout(command)): continue
         deviceName = "/dev/%s" % deviceShort
         if "hd" in deviceShort: #IDE Drives for DPU2000/3000
            if not "cdrom" in get_printout("ls -l /sys/block/%s/device/driver" % deviceShort)[0]:
               self.disks.append(Disk_OS(self.appliance, deviceName, hostNumber))

#===========
      for scsi in CONFIG.scsi_devices:
         # DGC for NAS
         # USB connection
         # Vendor: Initio  -- BlackX
         # Vendor: WDC  or ST330006 -- Tripp Lite v1
         # Vendor: WDC  or ST330006 -- AZIO   #??Sunplus
         # Vendor: Generic -- iStarUSA enclosure dock
         # Vendor: Jmicron -- Tripp Lite v2  (JMicron??)
         # Vendor: WDC  or ST330006 -- StarTech USB3
         # DGC for NAS

         #Not tested
         #if "tmp" in scsi.device:
         #   idx=get_nth_word("ls -l %s"%scsi.device, 5)
         #   for line in get_printout("ls -l /dev/sd[a-z]"): #vulernable for 4-letter device such as sdaa
         #      splits=line.split()
         #      if idx==splits[5]:
         #         scsi.device=splits[9]
            
            #[root@FLX_Unitrends ~]# lsscsi
            #[0:0:0:0]    disk    ATA      ST3000DM001-1CH1 CC24  /dev/sda
            #[1:0:0:0]    disk    ATA      ST3000DM001-1CH1 CC24  /dev/sdb
            #[2:0:0:0]    disk    ATA      ST3000DM001-1CH1 CC24  /dev/sdc
            #[3:0:0:0]    disk    ATA      ST3000DM001-1CH1 CC29  /dev/.tmp-8-48
            #[4:0:0:0]    cd/dvd  MATSHITA DVD-RAM UJ8C5    1.01  /dev/sr0
            #[root@FLX_Unitrends ~]# ls -l /dev/.tmp-8-48 /dev/sd[a-z]
            #brw-r----- 1 root disk 8,  0 Jul 14 04:44 /dev/sda
            #brw-r----- 1 root disk 8, 16 Jul 14 04:44 /dev/sdb
            #brw-r----- 1 root disk 8, 32 Jul 14 04:44 /dev/sdc
            #brwx------ 1 root root 8, 48 Jul 14 04:44 /dev/sdd
            #brw------- 1 root root 8, 48 Jul 14 09:44 /dev/.tmp-8-48

            
            
            
         
         if scsi.vendor in ["TWST"]:
            continue
         # Vendor becomes SEAGATE in case of SAS drive
         elif scsi.vendor in ["ATA","SEAGATE","Jmicron","Generic","Initio"] or "WDC" in scsi.vendor or "ST" in scsi.vendor: # single SATA drive
            isThisFlashcacheDevice =len(flashcacheDevice) and (flashcacheDevice==scsi.device)
            osdisk =Disk_OS(self.appliance, scsi.device, scsi.hostNumber, scsi, isThisFlashcacheDevice)
            self.disks.append(osdisk)
         elif "AMCC" in scsi.vendor:
            #if "U" in self.modelNo and isScanDoneForUs: return # for 2U and 3U
            if isScanDoneForUs: continue # sometimes there are two.....devices...
            isScanDoneForUs = True
            isDoneForHWRaid = True
            #bytes = int(get_nth_word("fdisk -l %s 2>&1| grep Disk | grep bytes" % deviceName, 4))
            #if bytes > 3099989016576: # 3TB single 3000592982016
            self.GetDisks_3Ware(scsi.vendor0, scsi.device)

         elif scsi.vendor in ["LSI", "SMC"]:  # LSI Drive
            isDoneForHWRaid = True

      
      if not isDoneForHWRaid:
         raidInfos = get_printout("%s info | /usr/bin/tail -2 | /usr/bin/head -1" % CONFIG.tw_cliPath )[0].split()
         unitInfos = get_printout("%s info %s | grep RAID"% (CONFIG.tw_cliPath, raidInfos[0]))[0].split()
         unitname = unitInfos[0].strip()
         RaidStatus =unitInfos[2].strip()

         if RaidStatus == "INOPERABLE":
            self.GetDisks_3Ware("AMCC")
            isDoneForHWRaid=True
         return

      

   def GetDiskDetails(self):
      if self.appliance.controller != "LSI":
      #if self.modelNo != "943" and self.modelNo != "824":
         disks = []
         for disk in self.disks:
            if not isinstance(disk, Disk_LSI):
               disks.append(disk)
            else:
               disks.append(disk)
         self.disks = disks      
               
      else:
         encIds, osDisks, lsiDisks, nDisk4encId, vdIds = [],[],[],[],[]
         for disk in self.disks:
            if not isinstance(disk, Disk_LSI):
               osDisks.append(disk)
            else:
               lsiDisks.append(disk)

         lsiDisks.sort(key=lambda Disk_LSI: Disk_LSI.slotNo)
         lsiDisks.sort(key=lambda Disk_LSI: Disk_LSI.encId)
         for disk in lsiDisks:    
            if disk.encId not in encIds:
               encIds.append(disk.encId)
               nDisk4encId.append(1)
               vdIds.append(disk.VD_Id)
            else:
               for i in range(len(encIds)):
                  if encIds[i]==disk.encId: nDisk4encId[i] +=1
         encIdTuple=[]
         for i in range(len(encIds)):
            encIdTuple.append( (encIds[i], nDisk4encId[i], vdIds[i]) )
                                                                     
         if self.appliance.FlipOrderFrontBack:  # Needs to count the drives to put the 24 (front bay) in front in output
            enum={}
            diskCnts=[]
            for i in range(len(encIds)):
               enum[encIds[i]] = i
               diskCnts.append(0)
               
            for disk in lsiDisks:
               diskCnts[enum[disk.encId]] +=1

            tuples =[]   
            for i in range(len(encIds)):
               tuples.append( (encIds[i], diskCnts[i]) )

            tuples.sort(key=lambda x: x[1], reverse=True)   # [('1', 24), ('0', 12), ('N/A', 3)]

            tmpLsiDisks=[]
            for tpl in tuples:
               theEncId = tpl[0]
               for disk in lsiDisks:
                  if disk.encId == theEncId:   tmpLsiDisks.append(disk)
            lsiDisks=[]
            lsiDisks=tmpLsiDisks

         #minValue = min(nDisk4encId)
         #maxValue = max(nDisk4encId)
         #minLocs = [i for i, j in enumerate(nDisk4encId) if j==minValue]
         #maxLocs = [i for i, j in enumerate(nDisk4encId) if j==maxValue]

         #self.fillDisks_LSI(encIdTuple,lsiDisks,encIds,osDisks)
         self.fillDisks_LSI_new(encIdTuple,lsiDisks,encIds,osDisks)



   def fillDisks_LSI_new(self,encIdTuple,lsiDisks,encIds,osDisks):
         
         bayNo,nonBayNo,theBayNo,nBayDrive,nDeadDrive = 0,0,0,0,0
         self.disks =[]
        
         if self.appliance.name in ["822","823","824"]:  # One EncId
            ref_encId=-9
            if len(encIdTuple): ref_encId=(encIdTuple[0])[0]
            for i in range(8): # Number of Bay
               found=False
               for disk in lsiDisks:
                  if disk.slotNo==i:
                     found=True
                     # The following condition is very important. If not working, then it will show duplicate bay number due to [:15} eg.
                     isNonBayDrive = "CacheCade" in disk.vdname or (not self.appliance.OSDriveLSIFrontBay and disk.model.capacity==1000)\
                         or "SSD" in disk.model.model or "Micron" in disk.model.model
                     if isNonBayDrive:
                        nonBayNo = nonBayNo +1
                     theBayNo=i
                     disk.SetDetailsForMatrix(theBayNo, isNonBayDrive, nonBayNo) # bayNo is being used by logger.py
                     disk.PrepLog("%02d" % theBayNo)  ###??? This is called before in Disk_LSI
                     self.disks.append(disk)
                     break
               if not found: 
                  diskToAppend = Disk_LSI(self.appliance, "", -1, "%d"%i, "Dead", ref_encId)
                  theBayNo=i
                  diskToAppend.SetDetailsForMatrix(theBayNo)
                  self.disks.append(diskToAppend)
                  self.IsThereDeadDrive =True
                  continue
                  
         elif self.appliance.name in ["823S","824S"]:  # One EncId
            ref_encId=-9
            if len(encIdTuple): ref_encId=(encIdTuple[0])[0]
            
            for i in range(11): # Number of Bay
               found=False
               for disk in lsiDisks:
                  if disk.slotNo==i:
                     found=True
                     # The following condition is very important. If not working, then it will show duplicate bay number due to [:15} eg.
                     isNonBayDrive = "CacheCade" in disk.vdname or (not self.appliance.OSDriveLSIFrontBay and disk.model.capacity==1000)\
                         or "SSD" in disk.model.model or "Micron" in disk.model.model
                     if isNonBayDrive:
                        nonBayNo = nonBayNo +1
                     theBayNo = int(disk.slotNo) -3
                     disk.SetDetailsForMatrix(theBayNo, isNonBayDrive, nonBayNo) # bayNo is being used by logger.py
                     disk.PrepLog("%02d" % theBayNo)  ###??? This is called before in Disk_LSI
                     self.disks.append(disk)
                     break
               if not found: 
                  diskToAppend = Disk_LSI(self.appliance, "", -1, "%d"%i, "Dead", ref_encId)
                  theBayNo = i-3
                  diskToAppend.SetDetailsForMatrix(theBayNo)
                  self.disks.append(diskToAppend)
                  self.IsThereDeadDrive =True
                  continue
                  
         elif self.appliance.name in ["933S","936S"]:  # One EncId
            encIdTuple.sort(key=lambda x: x[1]) # asc
            ref_encId=-9
            if len(encIdTuple)>1: ref_encId=(encIdTuple[1])[0]
            for i in range(16):
               found=False
               for disk in lsiDisks:
                  if disk.slotNo==i:
                     found=True
                     # The following condition is very important. If not working, then it will show duplicate bay number due to [:15} eg.
                     isNonBayDrive = "CacheCade" in disk.vdname or (not self.appliance.OSDriveLSIFrontBay and disk.model.capacity==1000)\
                         or "SSD" in disk.model.model or "Micron" in disk.model.model
                     if isNonBayDrive:
                        nonBayNo = nonBayNo +1
                     theBayNo = int(disk.slotNo)
                     disk.SetDetailsForMatrix(theBayNo, isNonBayDrive, nonBayNo) # bayNo is being used by logger.py
                     disk.PrepLog("%02d" % theBayNo)  ###??? This is called before in Disk_LSI
                     self.disks.append(disk)
                     break
               if not found:
                  diskToAppend = Disk_LSI(self.appliance, "", -1, "%d"%i, "Dead", ref_endId)
                  theBayNo = i-3
                  diskToAppend.SetDetailsForMatrix(theBayNo)
                  self.disks.append(diskToAppend)
                  self.IsThereDeadDrive =True
                  continue

            found =False  # check if SSD is alive or not
            for disk in lsiDisks:
               if disk.encId==(encIdTuple[0])[0]:
                  found =True
                  # The following condition is very important. If not working, then it will show duplicate bay number due to [:15} eg.
                  isNonBayDrive = "CacheCade" in disk.vdname or (not self.appliance.OSDriveLSIFrontBay and disk.model.capacity==1000)\
                      or "SSD" in disk.model.model or "Micron" in disk.model.model
                  if isNonBayDrive:
                     nonBayNo = nonBayNo +1
                  theBayNo = int(disk.slotNo)
                  disk.SetDetailsForMatrix(theBayNo, isNonBayDrive, nonBayNo) # bayNo is being used by logger.py
                  disk.PrepLog("%02d" % theBayNo)  ###??? This is called before in Disk_LSI
                  self.disks.append(disk)
            #if not found: Do Something for CacheCade dedth            
            #lsidisk = Disk_LSI(self.appliance, deviceName, theDeviceId, theSlotNo, theStatus, theEncId, theVdname, isVDCached, self.IsCacheCadeSetup, raidIdx, thePDType)#, diskgroup, span, arm
 


         elif self.appliance.name in ["943", "943S", "944S", "946S"]:
            encIdTuple.sort(key=lambda x: x[1], reverse=True) # desc
            for i in range(2):  # front and rear 24/12
               nBay=24
               if i==1: nBay=12  
               ref_encId=(encIdTuple[i])[0]
               ref_vdId=(encIdTuple[i])[2]
               for j in range(nBay):
                  found=False
                  for disk in lsiDisks:
                     if disk.encId==ref_encId and disk.slotNo==j:
                        found=True
                        isNonBayDrive = "CacheCade" in disk.vdname or (not self.appliance.OSDriveLSIFrontBay and disk.model.capacity==1000)      
                        if isNonBayDrive:
                           nonBayNo = nonBayNo +1
                        theBayNo = int(disk.slotNo) + i*24
                        disk.SetDetailsForMatrix(theBayNo, isNonBayDrive, nonBayNo) # bayNo is being used by logger.py
                        disk.PrepLog("%02d" % theBayNo)  ###??? This is called before in Disk_LSI
                        self.disks.append(disk)
                        break
                  if not found: 
                     diskToAppend = Disk_LSI(self.appliance, "", -1, "%d"%j, "Dead", ref_encId, "Virtual Drive: %s" % ref_vdId )
                     theBayNo = i*24 + j
                     diskToAppend.SetDetailsForMatrix(theBayNo)
                     diskToAppend.PrepLog("%02d" % theBayNo)
                     self.disks.append(diskToAppend)
                     self.IsThereDeadDrive =True
                     continue

            for disk in lsiDisks:
               if disk.encId==(encIdTuple[2])[0]:
                  isNonBayDrive = "CacheCade" in disk.vdname or (not self.appliance.OSDriveLSIFrontBay and disk.model.capacity==1000)\
                      or "SSD" in disk.model.model or "Micron" in disk.model.model
                  if isNonBayDrive:
                     nonBayNo = nonBayNo +1
                  theBayNo = int(disk.slotNo)
                  disk.SetDetailsForMatrix(theBayNo, isNonBayDrive, nonBayNo) # bayNo is being used by logger.py
                  disk.PrepLog("%02d" % theBayNo)  ###??? This is called before in Disk_LSI
                  self.disks.append(disk)

         for disk in osDisks:   
            self.disks.append(disk)
         
   #      if self.appliance.name in ["943", "943S", "944S", "946S"]:
 #           if self.appliance.name in ["823S","824S"]:
 #              theBayNo = int(disk.slotNo) -3
 #        min_encId = (encIdTuple[2])[1]
 #        rear_encId = (encIdTuple[1])[1]
 #        front_encId = (encIdTuple[0])[1]




   def fillDisks_LSI(self, encIdTuple,lsiDisks,encIds,osDisks):

         bayNo,nonBayNo,theBayNo,nBayDrive,nDeadDrive = 0,0,0,0,0
         self.disks =[]
         encIdTuple.sort(key=lambda x: x[1]) # asc
         min_encId = (encIdTuple[0])[1]

         for disk in lsiDisks:    ### This assumes 24 in front shows first and 12 in rear shows next......!!!! 943S shows differently
            if disk.encId != min_encId: nBayDrive+=1
            if self.appliance.name in ["943", "943S", "944S", "946S"]:
               if disk.encId not in encIds:
                  if len(encIds) > 0 and bayNo%12 !=0 and disk.encId >= 0 : # This is for the last drive in each enclosure Ids
                     diskToAppend = Disk_LSI(self.appliance, "", -1, "", "Dead", "")
                     nDeadDrive+=1
                     diskToAppend.SetDetailsForMatrix(bayNo)  
                     self.disks.append(diskToAppend)
                     nBayDrive+=1
                     self.IsThereDeadDrive = True
                     bayNo += 1
                  
               if disk.encId != min_encId and bayNo%24 != int(disk.slotNo) :
                  diskToAppend = Disk_LSI(self.appliance, "", -1, "", "Dead", "")
                  nDeadDrive+=1
                  diskToAppend.SetDetailsForMatrix(bayNo)  
                  self.disks.append(diskToAppend)
                  self.IsThereDeadDrive = True
                  bayNo += 1

            if self.appliance.name in ["823S","824S"]:
               theBayNo = int(disk.slotNo) -3
            elif self.appliance.name in ["822","823","824"]:
               theBayNo = int(disk.slotNo)
            else:
               theBayNo = bayNo
                  
            isNonBayDrive = "CacheCade" in disk.vdname or (not self.appliance.OSDriveLSIFrontBay and disk.model.capacity==1000)      
            disk.SetDetailsForMatrix(theBayNo, isNonBayDrive, nonBayNo) # bayNo is being used by logger.py
            disk.PrepLog("%02d" % theBayNo)  ###??? This is called before in Disk_LSI
            self.disks.append(disk)

            if isNonBayDrive:
               nonBayNo = nonBayNo +1
            else:   
               bayNo += 1

         if self.appliance.name in ["943", "943S", "944S", "946S"]:
            if (nBayDrive+nDeadDrive)<36: 
               diskToAppend = Disk_LSI(self.appliance, "", -1, "", "Dead", "")
               diskToAppend.SetDetailsForMatrix(bayNo)  
               self.disks.insert(len(self.disks)-1,diskToAppend)
               nBayDrive+=1
               self.IsThereDeadDrive = True
               bayNo = bayNo + 1

         for disk in osDisks:   
            self.disks.append(disk)


   def prep(self, arg):
      if not arg:
         return self.disks
      else:
         for disk in self.disks:
            if arg in disk.device:
               disks =[]
               disks.append(disk)
               return disks
         
   def printout(self):

      print "(3/6) Gbps (AF) 4k sector (E) External Drive (Archive)"
      print "(*) pending sector (x) too many realloc sector (s) seek-error-rate"
      if self.appliance.controller == "LSI" :
         print "(DD) Dead (F) Failed (FS) Failed-SMART available (UB) unconfigured bad (UG) unconfigured good (R) raid rebuild (OFF) offline"
         print "====            BAY#         DEV         PowerHours(Days)  Pend/Unc   Rlc      SER  nATA     WTB/   RTB          Drive Model         Serial Number      FWVer   Capacity"#omAirflw/Temprt(score) "
      else:
         if len(self.appliance.controller) >0: 
            print "(NP) NOT-PRESENT (DD) Dead (F) Failed (FS) Failed-SMART available (DE) DEVICE-ERROR (EE) ECC-ERROR (DG) DEGRADED"
         print "====                         DEV         PowerHours(Days)    Pend/Unc   Rlc      SER  nATA     WTB/   RTB   Drive Model                  Serial Number      FWVer  Capacity"#omAirflw/Temprt(score)"

            
      if self.modelNo == "943":
         DDDBDisk =0
         if len(self.disks)>36:
            if isinstance(self.disks[36], Disk_OS):  
               DDDBDisk =2
         if len(self.disks)>37:
            if isinstance(self.disks[37], Disk_OS):  
               DDDBDisk =1
            
         for i in range(len(self.disks)):
            disk = self.disks[i]
            if DDDBDisk==2 and i==36:
               print "6AF=  DD    DBINTN    /dev/sdb,-9      -9 (   -9 d)     0     0        0 (200/200>  0:    0)   WD1000CHTZ-04JCPV0       WD-############   04.06A00   1000 GB 0x6E"
               print "6AF=  DD    DBINTN    /dev/sdb,-9      -9 (   -9 d)     0     0        0 (200/200>  0:    0)   WD1000CHTZ-04JCPV0       WD-############   04.06A00   1000 GB 0x6E"
            elif DDDBDisk==1 and i==37:
               print "6AF=  DD    DBINTN    /dev/sdb,-9      -9 (   -9 d)     0     0        0 (200/200>  0:    0)   WD1000CHTZ-04JCPV0       WD-############   04.06A00   1000 GB 0x6E"

               
            print disk
      else:      
         for disk in self.disks:
            print disk


   ##############################
   def printLayout(self):         
      print "==================="

      nProb_ST3000NM0033 = 0

      for raid in self.raids:
         for disk in raid.problemDisks:
            if "ST3000NM" in disk.smart.modelName:
               nProb_ST3000NM0033 += 1
               
      if self.IsThereLSIDisk or self.IsThere3wareDisk:
         if self.IsThereLSIDisk:
            for i in range(len(self.raids)):
               print self.raids[i]

         if self.IsThere3wareDisk:
            for i in reversed( range(len(self.raids)) ):
               print self.raids[i]
         print "HW Controller: %s  FWVer %s" % (self.controllerName, self.fwVer)

      else:    
         for i in range(len(self.raids)):
            print self.raids[i]

      if self.prStatus == "Active":
         print "Patrol Read: %s" % self.prStatus
         
      print "==================="

      if CONFIG.selfhealing or CONFIG.confirm: return

      if "943" in self.modelNo:
         if len(self.disks) <10: return
         print "==== Front 24 drives ===="
         print "  ===BayNo[EnclosureDeviceID:SlotNumber]DeviceId===========Reallocated Sectors====Pending Sectors========Temperature Matrix==="#High Fly Writes==="
         for n in range(0, 6):
            print "    ", self.disks[5-n].word, self.disks[11-n].word, self.disks[17-n].word, self.disks[23-n].word, \
                  "   %5s" % self.disks[5-n].smart.realloc + " %4s" % self.disks[11-n].smart.realloc + \
                  " %4s" % self.disks[17-n].smart.realloc + " %4s" % self.disks[23-n].smart.realloc, \
                  "   %4s" % self.disks[5-n].smart.pending + " %4s" % self.disks[11-n].smart.pending + \
                  " %4s" % self.disks[17-n].smart.pending + " %4s" % self.disks[23-n].smart.pending, \
                  "    ", self.disks[5-n].smart.tempert, self.disks[11-n].smart.tempert, self.disks[17-n].smart.tempert, self.disks[23-n].smart.tempert
         print "==== Back 12 drives ===="
         print "  ===BayNo[EnclosureDeviceID:SlotNumber]DeviceId===========Reallocated Sectors====Pending Sectors========Temperature Matrix==="#High Fly Writes==="
         for n in range(0, 3):
            print "    ", self.disks[26-n].word, self.disks[29-n].word, self.disks[32-n].word, self.disks[35-n].word, \
                  "   %5s" % self.disks[26-n].smart.realloc + " %4s" % self.disks[29-n].smart.realloc + \
                  " %4s" % self.disks[32-n].smart.realloc + " %4s" % self.disks[35-n].smart.realloc, \
                  "   %4s" % self.disks[26-n].smart.pending + " %4s" % self.disks[29-n].smart.pending + \
                  " %4s" % self.disks[32-n].smart.pending + " %4s" % self.disks[35-n].smart.pending, \
                  "    ", self.disks[26-n].smart.tempert, self.disks[29-n].smart.tempert, self.disks[32-n].smart.tempert, self.disks[35-n].smart.tempert

         if isinstance(self.disks[36], Disk_OS):  return

         if isinstance(self.disks[37], Disk_OS):  
            
            print "==== DB drives ===="
            print "  ===DeviceId[EnclosureDeviceID:SlotNumber]================Reallocated Sectors====Pending Sectors========Temperature Matrix==="#High Fly Writes==="
            print "    ", self.disks[36].word, "    %28s" % self.disks[36].smart.realloc, \
                  "    %13s" % self.disks[36].smart.pending, "    %13s" % self.disks[36].smart.tempert
         else:
            print "==== DB drives ===="
            print "  ===DeviceId[EnclosureDeviceID:SlotNumber]================Reallocated Sectors====Pending Sectors========Temperature Matrix==="#High Fly Writes==="
            print "    ", self.disks[36].word, self.disks[37].word, \
                  "    %28s" % self.disks[36].smart.realloc + " %4s" % self.disks[37].smart.realloc,\
                  "    %13s" % self.disks[36].smart.pending + " %4s" % self.disks[37].smart.pending,\
                  "    %13s" % self.disks[36].smart.tempert, self.disks[37].smart.tempert




         if nProb_ST3000NM0033 > 0:
            print "%s Disk issue has been found in ST3000NM0033 model drive. Please, notify %s about this issue before replacing the drive." % (red("[ALERT]"), blue("wpark@unitrends.com"))
           
      elif "833-200" in self.assetTag or "833-300" in self.assetTag:
         print
         print "[INFO] This DPU (%s) has different disk bay configuration from 833-100-xxxxxx appliances:" % self.assetTag
         print get_printout("/sbin/lspci | grep 'RAID bus controller'")[0]
         print "\n==== Front Bays ===="
         disks =[]
         for n in range(len(self.disks)):
            if isinstance(self.disks[n], Disk_OS): continue
            disks.append(self.disks[n])


         outputs=[]   
         for i in range(12):
            output =''
            for n in range(len(self.disks)):
               if isinstance(self.disks[n], Disk_OS): continue
               if i==self.disks[n].slotNo:
                  output = "[%5s:%3s]" % (self.disks[n].portNo, self.disks[n].statusInitial)
                  break
            if not len(output): output="[NotRecgnz]"
            outputs.append(output)
            
         for n in range(0, 4):
            print "  %s    %s    %s    %s" % (outputs[3-n], outputs[7-n], outputs[11-n], "[EMPTY]") 

   ############################      
   def doAlert(self):

      for disk in self.disks:
         if not "?CACHE" in "%s"%disk: continue
         shortName  ="CacheCade"
         if not self.appliance.ndisk: shortName ="FlashCache"
         trapMessage ="%s not found due to disk(s):" % shortName

         trapTarget  = shortName + disk.trapTargAdd + "%s" % disk.statusInitial
         trapMessage += disk.trapMessAdd
         trapMessage = disk.SelfHeal(trapMessage) ##############

         if CONFIG.selfhealing: # delayedAlert handles... and CONFIG.dbON:
            notification_id = get_notification_id(trapMessage)
            HandleAlert(shortName, notification_id, trapTarget, trapMessage) # shortName is usually VD name


         
      IsThereDegraded = False
      for raid in self.raids: # one trap per raid
         IsDegraded = raid.alert()
         IsThereDegraded = IsThereDegraded and IsDegraded

      if not CONFIG.confirm and IsThereDegraded:
         print "\n>>>>>>>>>>>> ALERT SUMMARY <<<<<<<<<<<<<" 

      if "U" in self.modelNo:   
         raidInfos = get_printout("%s info | /usr/bin/tail -2 | /usr/bin/head -1" % CONFIG.tw_cliPath )[0].split()
         for line in get_printout("%s info %s | egrep 'RAID|SINGLE'"% (CONFIG.tw_cliPath, raidInfos[0])):
            print line
         
      if self.appliance.controller != "LSI": return

      if IsThereDegraded:
         if CONFIG.selfhealing:
            if "Disabled" in get_nth_word("%s -adpallinfo -a0 -NoLog| grep Alarm | grep abled" % CONFIG.MegaCli64_Path, 2):
               run_command("%s -adpsetprop alarmenbl -a0 -NoLog" % CONFIG.MegaCli64_Path) # CONFIG.confirm is embedded
      else:   
         if CONFIG.selfhealing:
            if "Enabled" in get_nth_word("%s -adpallinfo -a0 -NoLog| grep Alarm | grep abled" % CONFIG.MegaCli64_Path, 2):
               run_command("%s -adpsetprop alarmdsbl -a0 -NoLog" % CONFIG.MegaCli64_Path) # CONFIG.confirm is embedded

      return


   def anaLSILog(self):
      if self.appliance.controller == "LSI": 
         for line in self.MegaCliLdPdOutput:
            if 'Initialization:' in line:
               print "[INFO] %s" % line
      
         if not os.path.exists(CONFIG.lsiLogfile):
            print "Generating log file from LSI RAID CONTROLLER. Could take a while......"
            os.system("%s -AdpEventLog -GetEvents -info -f %s -a0 -NoLog" % (CONFIG.MegaCli64_Path, CONFIG.lsiLogfile))

         logs =[]
         slot =""
         for line in get_printout("grep DEGRADED %s -B 21 -A 5 | grep -E 'Time|Event Description'" % CONFIG.lsiLogfile ):
            if "Time" in line:
               timeh=line.split("Time:")[1][5:]
            elif "VD" in line:
               if "from" in line and not "ID=" in line:
                  state0 = line.split("from")[1]
                  words = state0.split("to")
                  state1 = words[1].strip()[0:-3]
                  state0 = words[0].strip()[0:-3]
                  
                  if get_state_index(state0) < get_state_index(state1):
                     prevState = state0
                     currState = state1
                     #print prevState, currState
                     #print line
                     logs.append(timeh + " %20s" % slot + "%20s" % prevState + "%20s" %currState)
            elif "PD" in line:
               if "FAILED" or "OFFLINE" in line:
                  slot = line.split()[6]
                  
         for line in get_printout("grep DEGRADED %s -B 5 -A 22 | egrep 'Time|Event Description'" % CONFIG.lsiLogfile ):
            if "Time" in line:
               timeh=line.split("Time:")[1][5:]
            elif "VD" in line:
               if "from" in line and not "ID=" in line:
                  state0 = line.split("from")[1]
                  words = state0.split("to")
                  state1 = words[1].strip()[0:-3]
                  state0 = words[0].strip()[0:-3]
                 
                  if get_state_index(state0) < get_state_index(state1):
                     prevState = state0
                     currState = state1
            elif "PD" in line:
               if "FAILED" in line:
                  slot = line.split()[6]
                  logs.append(timeh + " %24s" % slot + "%22s" % prevState + "%20s" %currState)

         if len(logs)>0:
            print "\n>>>>>>>>>>>> ANA LSILOG REPORT <<<<<<<<<<<<<"
            print "For 943 RAID ANALYSIS, please, copy and paste the following lines to wpark@unitrends.com !!!\n"
            os.system("date")
            os.system("cat /etc/unitrends-asset")
            os.system("%s -AdpAllInfo -a0 -NoLog | grep 'FW Version'" % CONFIG.MegaCli64_Path)
            os.system("/usr/local/bin/dpu version")
            #print "Power_On_Days: %3.0f" % (float(self.maxHour)/24.)

            for log in logs:
               print log
   

         print ""         
         for line in get_printout("%s fwtermlog dsply a0 nolog | grep Sense: | /usr/bin/tail -3" % CONFIG.MegaCli64_Path):
            print "[INFO] %s" % line
               

               
   def CheckConfigFile(self):

      config = ConfigParser.ConfigParser()
      config.read(CONFIG.configFile)
      newConfig =ConfigParser.ConfigParser()
      doneHosts =[]
      for disk in self.disks:
         if isinstance(disk, Disk_OS) and disk.archive:  #excluding eSATA drives 
            continue
         host =disk.nameForLogger
         if "-1" in host:  continue
         doneHosts.append(host)
         
         if CONFIG.verbose == "CheckConfigFile":
            print "WP newConfig : ", host, disk.smart.modelName, disk.smart.serialNumber

         newConfig.add_section(host)
         found =0
         if len(disk.smart.modelName):
            found=1
            newConfig.set(host, 'Model',  disk.smart.modelName)
            newConfig.set(host, 'Serial', disk.smart.serialNumber)
            newConfig.set(host, 'Found',  "%d"%found)
         else:
            if config.has_section(host):
               newConfig.set(host, 'Model',  config.get(host,"Model"))
               newConfig.set(host, 'Serial', config.get(host,"Serial"))
            else:
               newConfig.set(host, 'Model',  "")
               newConfig.set(host, 'Serial', "")
   
            newConfig.set(host, 'Found',  "%d"%found)
      ndisk = len(self.appliance.oshosts)

      IsThereEmptyBay = False
      firstHostN_OS=CONFIG.firstHostN_AHCI

      if CONFIG.verbose == "CheckConfigFile":
         print "WP ", firstHostN_OS, ndisk, doneHosts
         
      if firstHostN_OS >=0:
         for idHost in range(firstHostN_OS,firstHostN_OS+ndisk):
            theHost = "host%d" % idHost
            isdone = False
            for doneHost in doneHosts:
               if theHost == doneHost:
                  isdone = True
                  break
            if not isdone:
               IsThereEmptyBay = True
               newConfig.add_section(theHost)
               if not config.has_section(theHost):
                  newConfig.set(theHost, 'Model',  "")
                  newConfig.set(theHost, 'Serial', "")
                  newConfig.set(host, 'Found',  '0')
               else:
                  options = config.options(theHost)
                  if not "Model" in options:
                     newConfig.set(theHost, 'Model',  "")
                     newConfig.set(theHost, 'Serial', "")
                     newConfig.set(host, 'Found',  '0')
                  else:   
                     if not len(newConfig.get(theHost, "Model")):
                        newConfig.set(theHost, 'Model',  config.get(theHost, "Model"))
                        newConfig.set(theHost, 'Serial', config.get(theHost, "Serial"))
                        newConfig.set(host, 'Found',  '0')
                     else:
                        if config.get(theHost, "Model").strip()!=newConfig.get(theHost,"Model").strip() \
                               or config.get(theHost, "Serial").strip()!=newConfig.get(theHost,"Serial").strip(): 
                           newConfig.set(host, 'Found', '1')
      needUpdate =False
      if not os.path.exists(CONFIG.configFile):
         needUpdate =True
      else:
         if not IsThereEmptyBay:
            config =ConfigParser.ConfigParser()
            config.read(CONFIG.configFile)

            same =True
            for host in config.sections():
               if not newConfig.has_section(host):
                  same =False
                  break
               same =same and config.get(host, "Model").strip()  == newConfig.get(host, "Model").strip()
               same =same and config.get(host, "Serial").strip() == newConfig.get(host, "Serial").strip()
               if config.has_option(host,"Found"):
                  same =same and config.get(host, "Found").strip()  == newConfig.get(host, "Found").strip()
               else:
                  same =False

            needUpdate =not same   
         else:
            needUpdate =True

      if needUpdate:
         if os.path.exists(CONFIG.configFile):
            os.system("cp %s %s.bak" %(CONFIG.configFile, CONFIG.configFile))
         cfgfile = open(CONFIG.configFile,'w')
         newConfig.write(cfgfile)
         cfgfile.close()

      return needUpdate

#####################################
class UnitElement:  # struct for 3ware unit elements such as u0-0, etc
   pass

def getApplianceDetail(modelNo):
   if modelNo[0] == "A":
      modelName = ""
      raidInfos = get_printout("%s info | /usr/bin/tail -2 | /usr/bin/head -1" % CONFIG.tw_cliPath)[0].split()
      if "c" in raidInfos[0]:
         if int(raidInfos[2]) == 12:
            modelName = "3U"
         elif int(raidInfos[2]) == 8:
            modelName = "2U"
      if len(modelName)>0:
         for model in list_of_appliance():
            if modelName == model.name:
               return model

   elif modelNo[1] == "U":
      oshosts =[]
      raidInfos = get_printout("%s info | /usr/bin/tail -2 | /usr/bin/head -1" % CONFIG.tw_cliPath )[0].split()
      unitInfos = get_printout("%s info %s | grep RAID" % (CONFIG.tw_cliPath, raidInfos[0]))[0].split()
      N_Drive = get_first_word("%s info %s %s | grep %s | grep -v RAID | grep -v Volume | wc -l" % (CONFIG.tw_cliPath, raidInfos[0], unitInfos[0], unitInfos[0]))
      return Appliance(modelNo[0:2], int(N_Drive)  , False,  -1, 5,  64, "3ware", oshosts)

   else:
      for model in list_of_appliance():
         if modelNo == model.name:
            return model

   oshosts = ["host1", "host2"]
   return Appliance("Unk",  0, False,  0, 0,  256, "", oshosts)


def anaUEB():
   print ""
   output = "[  This is UEB on "

   if len(get_printout("/sbin/lsmod |grep vmxnet")):
      output += "ESX"
   if len(get_printout("/sbin/lsmod |grep vmbus")):
      output += "HyperV"

   print output+" Host  ]\n"

   for line in get_printout("/usr/local/bin/dpu asset"):
      print line

   print ""   
   for line in get_printout("/usr/local/bin/dpu version"):
      print line

   print ""   

   vgname = ""
   for line in get_printout("%s/vgdisplay | egrep 'VG Name|VG Size'" % CONFIG.lvm_Path):
      words = line.split()
      if words[1] == "Name":
         vgname = words[2]
      if words[1] == "Size":
         print "Volume Group:  %s ( %s %s )" % (vgname, words[2], words[3])

   print "   - Logical Volumes: "
   lvname = ""
   for line in get_printout("%s/lvdisplay | egrep 'LV Name|LV Size'" % CONFIG.lvm_Path):
      words = line.split()
      if words[1] == "Name":
         lvname = words[2]
         for i in range(25-len(lvname)):
            lvname += " "
            
      if words[1] == "Size":
         print "     -- %25s ( %s %s )" % (lvname, words[2], words[3])

   print "   - Physical Volumes: "
   pvname = ""
   for line in get_printout("%s/pvdisplay | egrep 'PV Name|PV Size'" % CONFIG.lvm_Path):
      words = line.split()
      if words[1] == "Name":
         pvname = words[2]
         for i in range(25-len(pvname)):
            pvname += " "
            
      if words[1] == "Size":
         print "     -- %25s ( %s %s )" % (pvname, words[2], words[3])

#===================
def io_error_check(appliance):
   os.system("grep 'end_request: I/O error' /var/log/messages* > /tmp/io_error_result")
   if os.path.exists("/tmp/io_error_result"):
      lines = get_printout("/usr/bin/head -1 /tmp/io_error_result")

      # /var/log/messages:Mar  2 07:00:02 CVUnitrends02 kernel: end_request: I/O error, dev sdd, sector 0

      for line in lines:

         words=line.split("kernel: end_request:")
         segs=words[1].split()
         deviceShort=(segs[3])[:-1] # take out comma
         
         isRaidRelated = False
         if "md" in deviceShort                    : isRaidRelated = True   #md5  : Software RAID 
         if "dm" in deviceShort or "md99" in deviceShort: return
         if os.path.exists("/sys/block/%s/device/vendor" % deviceShort):
            if get_first_word("cat /sys/block/%s/device/vendor" % deviceShort) in ["LSI", "SMC", "AMCC"]:
               isRaidRelated = True

         ndisk =appliance.nDisk_OS_and_Cache_for_archive # 602/603 issue host0/2  to cover in between host1 to exclude it
         hostNumber=get_hostnumber(deviceShort)
         firstHostN_OS=CONFIG.firstHostN_AHCI
         if not(hostNumber>=firstHostN_OS and hostNumber<firstHostN_OS+ndisk):
            return
            
         if isRaidRelated:   
            print "%s" % red(line)
      
   return
         
def xfs_check(appliance):
   
   lines = get_printout("grep 'xfs_log_force' /var/log/messages | grep error | /usr/bin/head -1")
   if len(lines):
      words = lines[0].split('kernel:')

      #descr would be :
      #CentOS5: Filesystem "sdc": xfs_log_force: error 5 returned
      #CentOS6: XFS (sdc): xfs_log_force: error 5 returned.
      descr = words[1].strip()[:-1]
      deviceShort = (descr.split()[1])[1:-2] # e.g. sdc 

      isRaidRelated = False
      if "md" in deviceShort                    : isRaidRelated = True   #md5  : Software RAID 
      if "dm" in deviceShort or "md99" in deviceShort: isRaidRelated = False  #dm-0 : LVM for Recovery Archive
      if os.path.exists("/sys/block/%s/device/vendor" % deviceShort):
         if get_first_word("cat /sys/block/%s/device/vendor" % deviceShort) in ["LSI", "SMC", "AMCC"]:
            isRaidRelated = True

      ndisk =appliance.nDisk_OS_and_Cache_for_archive # 602/603 issue host0/2  to cover in between host1 to exclude it
      hostNumber=get_hostnumber(deviceShort)
      firstHostN_OS=CONFIG.firstHostN_AHCI
      if not(hostNumber>=firstHostN_OS and hostNumber<firstHostN_OS+ndisk):
         isRaidRelated=False
            
      message = "%s " %(words[0][0:16])
      if not isRaidRelated: message += "[Archive Media] "
      message += "%s" % words[1].strip()[:-1]
         
      problemIdx = 0
      lines = get_printout("egrep 'Unclean shutdown detected|resetting card' /var/log/messages* | egrep 'Unclean|resetting'")
      for line in lines:
         #/var/log/messages.3:Nov  9 08:01:10 uvault6a kernel: 3w-9xxx: scsi0: AEN: WARNING (0x04:0x0008): Unclean shutdown detected:unit=0.
         #[ALERT] /var/log/message 3w-9xxx: scsi0: AEN: WARNING (0x04:0x0008): Unclean shutdown detected:unit=0
         print line
         if "Unclean" in line:
            if not problemIdx & 1:
               problemIdx += 1
         elif "resetting" in line:
            if not problemIdx & 2:
               problemIdx += 2
            
         words = line.split('kernel:')
         ws =words[0].split(":")
         print ws
         mess = "%s:%s:%s " % (ws[1], ws[2], ws[3]) + words[1].strip()[:-1]
         print ">>>> %s" % mess
         
      if problemIdx > 0:
         message += " due to "
         if problemIdx & 1:
            message += "unclean shutdown "
         if problemIdx & 2:
            message += "resetting card "

      print bcolors.RED + "[ALERT]" + bcolors.ENDC + " %s" % message
            
      if isRaidRelated:      
         HandleAlert("XFS", 137, "XFS", message) #shortName is VD name
   else:
      CloseAnyActiveAlerts("XFS")

######################
def init():

   if opts.install:
      if CONFIG.majorVersion<7:
         print "installation is not supported before version 7.X"
         return False
      if dirname in ["/root/", "/root/benchmark/"]: # only if hoxfix or development
         print "Updating bp software for disk monitor suite manually!!!"
         command ="cp disk_monitoring_logger.py /usr/bp/bin/disk_monitoring.py"
         print command
         os.system(command)

         command ="cp diskmon/bin/raidInfo /usr/bp/bin/"
         print command
         os.system(command)

         command ="cp diskmon/lib/*py /usr/bp/lib/monitoring/"
         print command
         os.system(command)
      else:
         print "[ERROR] Installation is available only from /root/ "
         return False
      
   
   if int(get_first_word("ps aux | grep '/usr/bp/bin/disk_monitoring.py -s -c' | grep -v grep | wc -l")) > 2:
      command ="ps aux | grep '/usr/bp/bin/disk_monitoring.py' | grep -v grep"
      lines =get_printout("ps aux | grep '/usr/bp/bin/disk_monitoring.py' | grep -v grep")

      print "disk_monitoring log seems to be stuck due to postgres VACUUM (%d lines) !!" % len(lines)
      print "One may check with the command, %s" % command
      return True

   if dirname == "/root/" and not CONFIG.quick: # only if supporting case
      # If ftp site is reachable then ftp update process will be aborted after 1 second
      if int(get_first_word("/bin/ping %s -W 1 -c 1 2>&1 | /bin/grep -E 'Unreachable|100%% packet loss|unknown host' | /usr/bin/wc -l" %_ftpSite)):
         return True
      
      lines     = get_printout("%s -N %s/%s 2>&1 | grep %s | grep -v ftp | grep -v ="\
                                  % (_wgetPath, _ftpPath, basename, basename[0:5]))
      lines_lib = get_printout("%s -N %s/%s.tgz 2>&1 | grep %s | grep -v ftp | grep -v ="\
                                  %(_wgetPath, _ftpPath, basename, basename[0:5]))

      IsDownloaded = 0
      if len(lines)==0 and len(lines_lib)==0:
         return True
      if len(lines)>0:
         if "saved" in lines[0]:
            IsDownloaded += 1
      if len(lines_lib)>0:
         if "saved" in lines_lib[0]:
            IsDownloaded += 2
      
      if IsDownloaded:
         print "================================================================================"
         print "New version found and downloaded! It's automatically re-run!! Wait for a while!!"
         print "================================================================================"

         if IsDownloaded >= 2:
            os.system("rm -rf diskmon; /bin/tar zxf %s.tgz" % basename)

         theCommand = "%s"% abs_path
         if CONFIG.lsigetlinux:
            theCommand += " --lsigetlinux"
         if CONFIG.upload:
            theCommand += " --upload"
         if CONFIG.detailSMART:
            theCommand += " --detailSMART"
         if CONFIG.new:
            theCommand += " --new"
         #if CONFIG.dailySMART:
         #   theCommand += " --dailySMART"
            
         os.system("%s"% abs_path)
         return False

   #if CONFIG.dailySMART:
   #   files = get_printout("/bin/ls %s/*smart 2>&1 | grep -v cannot" % CONFIG.directory_paths[CONFIG.ibase])
   #   for filename in files:
   #      print filename
   #   return False   
      
      
   if CONFIG.lsigetlinux:
      command  = "%s -N %s/lsigetlinux_062014.tgz 2>&1 " % (_wgetPath, _ftpPath)
      command += "| grep lsigetlinux | grep -v ftp | grep -v ="
      lines     = get_printout(command)
      run_command("tar zxf lsigetlinux_062014.tgz",0,True)  # True is just for confirm
      os.chdir("./lsigetlinux_062014")
      run_command("./lsigetlunix.sh", 0, True)

      if CONFIG.upload:
         tarfilename = get_first_word("ls -t lsi*tar.gz")
         newfilename = CONFIG.assetTag + "_" + tarfilename
         run_command("mv %s %s" %(tarfilename, newfilename), 0, True)
         extraPath = "/mnt/EBS-01/ftp/utilities/tmp/"
         command = "scp %s unitrend@ftp.unitrends.com:%s" % (newfilename, extraPath)
         run_command(command, 0, True)
      #Alternatively through tunnel server:
      #scp -C -P 222 lsi.linux.Recovery-943-Madison.110713.194804.tar.gz wpark@tunnel.unitrends.com:~/
      #scp -P 222 wpark@192.168.185.177:~/lsi*tar.gz .
      return False
   
   if CONFIG.list:
      print "\nThe following shows the list of appliances which this script support:\n";
      list_of_appliance(True)
      return False

   if CONFIG.listOfDisks:
      print "\nThe following shows the list of disks available in dictionary:\n";
      list_of_device(True)
      return False

   if CONFIG.showVersion:
      versionDescriptions = [
         ## Hasn't been done with SPAN distinguish in case of different span drive in RAID60
         "Big Iron Integration (944/946): change a rule to deal with alert, snmptrap and selfheal",
         "In case of multiple drive degrades, check the size from pdgetmissing",
         "MegaCli: Enclosure Device ID, slot ID base missing drive identification",
         "Alert shows the serial number all the times: logger revised",
         "Alert/SNMP trap is sent in case of cachcade/flashcache being down",
         "-------------8.1.0-------------",
         "raidInfo integration",
         "Removed maxHourSpanForPendingSector",
         "Tighter mdraid drive check for the case of 4 letter device name",
         "Start using lsscsi output (or /proc/scsi/scsi) and reorganize the code accordingly",
         "833-200 or higher layout information revision based on slotNo",
         "Moving OptParser to config; Using lsscsi output to handle scsi, pci information",
         "-------------8.0.0-5----------------",
         "172 archive drive recognition issue (#1148)",
         "833 9750 virtual port issue starting from 0 intead of 8",
         "-------------8.0.0-3----------------",
         "Change the key from .el6. to el6 to check the CentOS version",
         "Change the order of postDocumentation before .alert()",
         "Distinguish nDisk_OS_and_Cache_for_archive from nDisk_OS_and_Cache",
         "Fix non alert posting in case of dead drive",
         "Fix Bay# in 824S, 823S",
         "Fix didControllerVerify to use correct reference",
         "Fix Cachecade status",
         "Show patrol read status, ra/stripesize (swraid) and extra SMART values in crontab run",
         "Add lsiLog and twcliLog",
         "-------------7.5.1----------------",
         "Fix the duplicate name of disk for logger", 
         "Fix to send degraded trap when partial degrade happens in mdraids",
         "Fix to send rebuild progress trap when mdraid is in rebuild",
         "Fix to show model and serial number for offline drive",
         "Change the sequence of logic in LSI controller: get raids and then disks; thus better in duplicate drive resolution", 
         "Validated for 824S, 936S, 943S",
         "Handling miniSAS card sharing common host number over multiple devices",
         "Handling space in model name in logger.py",
         "Restructured in LSI drive recognition using LdPdInfo",
         "Sync with unitrends-snmp",
         "BayNumber is shown in 1U (disk.py, appliance.py)",
         "Revise get_firstHostN_OS() to run only one time (raid.py)",
         "OS RAID degrade trap message showing device name and health info",
         "Treatment of resync in mdadm v3.2.6 added",
         "SMC is added with LSI in vendor name to decide the Disk type",
         "NewDock: Default smartctl option is -d sat; vendor JMicron is added in OS drive filtering condition in main",
         "Intel/Crucial SSD smart value revised",
         "Check archive_only_usb string in platform_capabilities to exclude more onboard SATA drives out of archiving",
         "Revised to filter false archive drive out using mdstat info (only happens two os drives connected to hots0/host2 and single drive archive",
         "Fix single drive appliance case such as 201, 171, etc", 
         "Swap the order of bpdb and config in hierachy",
         "Add --showTemp",
         "Revised OS drive locating message (support_messages.py)",
         "New gen appliances added: desktop and 1U (appliance.py)",
         "Recognition of flashcache (disk.py)",
         "Adding IO error for interactive purpose (main)",
         "Adding 6TB, 128/256GB Crucial SSDs in dictionary (device.py)",
         "Sending SN and WTB in trap (raid.py)",
         "Close the status of snmp trap raid becomes healthy (util.py)",
         "Fix archive drive recognition based on proc_name in CentOS5 (disk.py)",
         "Hardening host number recognition in RAID_OS (raid.py)",
         "Hardening diskConfig.ini extraction in case of host number getting changed (logger.py)",
         "postDocumentation moved before doAlert (disk_monitoring.py)",
         "logger hardened for the device host number being changed (logger.py)",
         "Add CONFIG.confirm in alert, psa and audit (trap.py)",
         "-------------7.5.0-6----------------",
         "Add an intel to exclude archive drive out of XFS corruption trap",
         "Fix to recognize external drive in CentOS6",
         "Fix to handle 822/3-300 (LSI controller) correctly",
         "Add ST3000DM001-1E6166 added",
         "-------------7.5.0-4----------------",
         "Capturing ATA errors in a log and showing it in disk monitoring output",
         "SMART attribute threshold update",
         "maxHourSpanForPendingSector exception fix",
         "Raid_OS class patch for CentOS6 to identify OS drive correctly",
         "Fix to let trap from monitoring tool show hyperVisor type and license type (OID .7) in case of UEB",
         "-------------7.5.0-2----------------",
         "Toshiba Enterprise Drive to be in disk monitoring script dictionary",
         "-------------7.4----------------",
         "Adding new WD 4TB disk",
         "824 external disk recognition fix",
         "LSI disk rebuild with correct array and row number",
         "Send a trap even for non fatal severity",
         "Show bay number in 1U based on hostNumber",
         "-------------7.3.0-5------------",
         "Dead drive in LSI",
         "absolute path issue for LSI RAID",
         "943 last HW raid drive fail issue",
         "Adding couple more new enterprise drives", 
         "Fix not to show R with benign ECC-ERROR in 3ware", 
         "Adding WD1003FBYX-01Y7B0",
         "Displaying ALERT for Seagate Enterprise Drive",
         "Dealing with MegaSAS.log",
         "Independence of database by making hyprid path through text file instead of database",
         "-------------7.3.0-1------------",
         "XFS corruption check",
         "Delayed Alert", "Selfhealing for software raid 1 with 2 drives",
         "clearing trap",
         "Add HW RAID controller information",
         "Show how to make specific green light blinking",
         "Bugfix for last verified time calculation",
         "Adding Seagate Enterprise 3TB drive",
         "Make sure if controller verified pending sector",
         "Send SMART alert during the office hour 0600 to 1459",
         "Fix for dual device under 3ware controller",
         "progressMessage fix for 3ware disk",
         "Recovery-300 change",
         "SER threshold to 31",
         "3ware limited self-healing with proper trap sending",
         "Fix to show R instead of DG when REBUILD-INIT in 3ware",
         "physdrv [E:S] to physdrv[E:S]", "Handling 3U with 2 RAID card", 
         "Limit the number of self-healing attemp", "Handling obsolete log file", "Showning Disk Firmware Version", 
         "Pending Sector should be present at least 24 hours ", "ECC-ERROR with WARNING at unit level is considered as benign", 
         "Tagged for SER if worst is less than 30", 
         "Fix it for 2U and 3U", "Fix inoperable raid handling for 3ware", 
         "Fix Crontab Environment", "Archive Label", "Better Bay# in 943", "Legacy tag with A000 handling", 
         "04292013: Empty log file handling", "Further hardening for CentOS 6", "943 maximum rebuild attempt; 833-200"
         ]

      print "Script version: %s" % CONFIG.scriptVersion
      for desc in versionDescriptions:
         print "[ChangeLog]   %s" % desc
      return False

   for directory_path in CONFIG.directory_paths:
      if not os.path.exists(directory_path):
         print "%s " % directory_path + " does not exist. Creating one..."
         os.system("mkdir %s" % directory_path)

#   # cronjob registering      
#   abs_path = os.path.abspath(sys.argv[0])
#   basename = os.path.basename(sys.argv[0])
#   for line in get_printout("/usr/bin/tail -20 /etc/crontab"):
#      if basename in line: #it could be path + filename...
#         return True # no need to do it
#
#   print "This job is being registered in crontab for hourly running"
#   command = "echo '' >> /etc/crontab; echo '01 * * * * root %s" % abs_path +" > /dev/null 2>&1' >> /etc/crontab"
#   #   print command 
#   os.system(command)

   if os.path.exists("/MegaSAS.log"):
      os.system("rm /MegaSAS.log")
   if os.path.exists("/root/MegaSAS.log"):
      os.system("rm /root/MegaSAS.log")

   return True
###      
def get_digit_from_month(month):
   months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', \
                'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec']
   for i,s in enumerate(months):
      if s == month:
         return i+1
      
#===================
if __name__ == '__main__':

   tw_cliPath = "/usr/local/bin/tw_cli"
   if not os.path.exists(tw_cliPath):
      tw_cliPath = "/usr/sbin/tw_cli"
      if not os.path.exists(tw_cliPath):  #621-100-00007 old legacy
         tw_cliPath = "/opt/AMCC/CLI/tw_cli"
      
   MegaCli64_Path = "/usr/sbin/MegaCli64"
   if not os.path.exists(MegaCli64_Path):
      MegaCli64_Path = "/opt/MegaRAID/MegaCli/MegaCli64"

   smartctl_Path = "/usr/sbin/smartctl"
   CONFIG.tw_cliPath = tw_cliPath
   CONFIG.MegaCli64_Path = MegaCli64_Path
   CONFIG.smartctl_Path = smartctl_Path
   CONFIG.lvm_Path = "/usr/sbin"
   if CONFIG.CentOS_version==6:
      CONFIG.lvm_Path = "/sbin"

   raidInfo_Path = "%s/diskmon/bin/raidInfo" % dirname
   if dirname == "/usr/bp/bin/": # only if supporting case
      raidInfo_Path = "/usr/bp/bin/raidInfo"
   CONFIG.raidInfo_Path = raidInfo_Path   

   main()



#################class RAID#########################
#class RAID:           
#class RAID_LSI(RAID):
#      alert()    # this is sending alert and snmp trap
#class RAID_3ware(RAID):
#      alert()    # this is sending alert and snmp trap
#class RAID_OS(RAID):
#      alert()    # Especially RAID_OS it does prepare trap message (potentially self-healing) and sending alert and snmp trap
#      set_config()
#class MdRaid:     """MdRaid which will be subset of RAID_OS""" 
#################class DPU ##########################
#class DPU:
#class Alert: # for the table "bp.alerts"
#class SMART: # struct for Disk class
#class UnitElement:  # struct for 3ware unit elements such as u0-0, etc

#################class Disk ##########################
#class Disk:  # inheritance: Disk_LSI, Disk_3ware, Disk_OS
#  PrepLog() FillSMART()

#class Disk_LSI(Disk):
#  SelfHeal()   #This is actual self-healing and prepare trap message
#class Disk_3ware(Disk):
#  SelfHeal()   #This is actual self-healing and prepare trap message
#class Disk_OS(Disk):
#################class SubPartition ##########################
#class SubPartition:
#################class Appliance ##########################
#class Appliance:
#################class Device ##########################
#class Device:
#class bcolors:
                                                   

#doc-1
   #[root@Recovery-943 tmp]# wget -N ftp://ftp.unitrends.com/utilities/disk_monitoring_logger.py 2>&1 | grep disk | grep -v ftp | grep -v =
   #2013-02-26 13:45:05 (499 KB/s) - `disk_monitoring_logger.py' saved [63680]
   #[root@Recovery-943 tmp]# wget -N ftp://ftp.unitrends.com/utilities/disk_monitoring_logger.py 2>&1 | grep disk | grep -v ftp | grep -v =
   #Remote file no newer than local file `disk_monitoring_logger.py' -- not retrieving.
   #if check_word_in_output("saved", "/usr/bin/wget -N ftp://ftp.unitrends.com/utilities/disk_monitoring_logger.py 2>&1 | grep disk | grep -v ftp | grep -v ="):

      # due to ftp problem... I did....
      #[root@unitrends833b ~]# wget -N ftp://ftp.unitrends.com/utilities/disk_monitoring_logger.py
      # --2013-09-10 15:15:59--  ftp://ftp.unitrends.com/utilities/disk_monitoring_logger.py
      #           => `.listing'
      #Resolving ftp.unitrends.com... 50.19.127.159
      #Connecting to ftp.unitrends.com|50.19.127.159|:21... connected.
      #Logging in as anonymous ... Logged in!
      #==> SYST ... done.    ==> PWD ... done.
      #==> TYPE I ... done.  ==> CWD /utilities ... done.
      #==> PASV ... done.    ==> LIST ...
      #No such file or directory `.'.
      #unlink: No such file or directory

      # discouraged due to intensive traffic to ftp server...
      #   elif dirname == "/usr/bp/bin/": # only if supporting case
      #      if "saved" in get_printout("/usr/bin/wget -N ftp://ftp.unitrends.com/utilities/usr/bp/bin/%s 2>&1 | grep %s | grep -v ftp | grep -v =" %(basename, basename[0:5]))[0]:
      #         print "===================================================================================="
      #         print "New version is found and downloaded!! It's automatically re-run!! Wait for a while!!"
      #         print "===================================================================================="
      #         os.system("%s"% abs_path)
      #         return False

