import os,sys
abs_path = os.path.abspath(sys.argv[0])
basename = os.path.basename(sys.argv[0])
dirname = abs_path.replace(basename, "")
if not "%s/diskmon/lib" % dirname in sys.path:
   sys.path.append("%s/diskmon/lib" % dirname) # always with regard to parent script
if not "/usr/bp/lib/monitoring" in sys.path:
   sys.path.append("/usr/bp/lib/monitoring")
from config     import *
from util       import get_first_word

_flashcache       =0
_archive_only_usb =0
_cachecade        =0
_rebuild_disk_mode=0
if os.path.exists("/var/opt/unitrends/platform_capabilities"):
   _flashcache =int(get_first_word("/bin/grep flashcache /var/opt/unitrends/platform_capabilities | /usr/bin/wc -l"))
   _cachecade  =int(get_first_word("/bin/grep cachecade /var/opt/unitrends/platform_capabilities | /usr/bin/wc -l"))
   _archive_only_usb = int(get_first_word("/bin/grep archive_only_usb /var/opt/unitrends/platform_capabilities | /usr/bin/wc -l"))
   _rebuild_disk_mode = int(get_first_word("/bin/grep rebuild_disk_mode /var/opt/unitrends/platform_capabilities | /usr/bin/wc -l"))
#################class Appliance ##########################
class Appliance:
   """Holding partition information from smartctl"""
   def __init__(self, name, ndisk, onboardSata, mdlevel, raidlevel, stripe, controller, oshosts, nCPU=0, RAM=0, \
                   dedicatedDBHWDisk=False, OSDriveLSIFrontBay=False, FlipOrderFrontBack=False):
      self.name       = name
      self.ndisk      = ndisk      #number of disk in hwrd
      self.onboardSata= onboardSata
      self.mdlevel    = mdlevel
      self.raidlevel  = raidlevel  #/backups partition
      self.controller = controller #
      self.oshosts    = oshosts
      self.nCPU       = nCPU
      self.RAM        = RAM
      self.DBonHWR    = dedicatedDBHWDisk
      self.OSDriveLSIFrontBay = OSDriveLSIFrontBay
      self.FlipOrderFrontBack = FlipOrderFrontBack
      
      self.flashcache = _flashcache # int(get_first_word("/bin/grep flashcache /var/opt/unitrends/platform_capabilities | /usr/bin/wc -l"))
      self.cachecade  = _cachecade  # int(get_first_word("/bin/grep cachecade /var/opt/unitrends/platform_capabilities | /usr/bin/wc -l"))
      self.nDisk_OS_and_Cache = len(oshosts)
      self.archive_only_usb = _archive_only_usb #int(get_first_word("/bin/grep archive_only_usb /var/opt/unitrends/platform_capabilities | /usr/bin/wc -l"))
      self.rebuild_disk_mode = _rebuild_disk_mode
      
      if self.flashcache:
         self.nDisk_OS_and_Cache +=1

      self.nDisk_OS_and_Cache_for_archive =self.nDisk_OS_and_Cache     
      if self.archive_only_usb:  # 602/603 issue host0/2  to cover in between host1 to exclude it
         self.nDisk_OS_and_Cache_for_archive +=1
         
      self.showBayNumbersIn1U =False
      if name in ["712", "713", "812", "813", "713S", "714S", "814S", "816S"]:
         self.showBayNumbersIn1U =True
      self.flashcache_in_front=False
      if self.flashcache and name in ["714S", "814S", "816S"]:
         self.flashcache_in_front=True

         
      
   def printout(self):
      print "Recovery-%3s" % self.name + "      HWRD NDISK =%2d" % self.ndisk + "      OS MD RAID= %2d" % self.mdlevel \
            + "      /backups partition RAID= %2d" % self.raidlevel \
            + "       raidController %9s " %self.controller 

def list_of_appliance(doPrint=False):
   list=[]

   assetTag = CONFIG.assetTag

   oshosts =[]
   list.append(Appliance("620",  3, False,  -1, 5,  64, "3ware", oshosts))
   list.append(Appliance("2U",   6, False,  -1, 5,  64, "3ware", oshosts))
   list.append(Appliance("3U",  12, False,  -1, 5,  64, "3ware", oshosts))

   list.append(Appliance("171",  0, True,   1, -1, 0, "", ["host0"])) # 1TB x 1
   list.append(Appliance("172",  0, True,   1, -1, 0, "", ["host0"]))
   oshosts = ["host0", "host1"]
   list.append(Appliance("211",  0, True,   1, -1, 0, "", oshosts)) # 1TB x 2
   list.append(Appliance("212",  0, True,   1, -1, 0, "", oshosts))
   list.append(Appliance("311",  0, True,   1, -1, 0, "", oshosts)) # 1.5TB x 2 and usb only
   list.append(Appliance("312",  0, True,   1, -1, 0, "", oshosts))
   list.append(Appliance("313",  0, True,   1, -1, 0, "", oshosts))
   list.append(Appliance("411",  0, False, 10, -1, 0, "", oshosts))
   
   list.append(Appliance("214EX",  0, True,   1, -1, 0, "", oshosts)) # 1TB x 2

   ## new appliance
   list.append(Appliance("201",  0, True,   1, -1, 0, "", ["host0"])) # 1TB x 2
   list.append(Appliance("602",  0, True,   1, -1, 0, "", oshosts))   # 2TB x 2
   list.append(Appliance("603",  0, True,   1, -1, 0, "", oshosts))   # 3TB x 2
   list.append(Appliance("604",  0, True,   1, -1, 0, "", oshosts))   # 4TB x 2

   list.append(Appliance("612",  0, False,  1, -1, 0, "", oshosts))

   oshosts = ["host0", "host1", "host2", "host3"]
   list.append(Appliance("300",  0, True,   1, -1, 0, "", oshosts)) # onboard SATA eSATA True
   list.append(Appliance("511",  0, False, 10, -1, 0, "", oshosts))
   list.append(Appliance("610",  0, False, 10, -1, 0, "", oshosts))
   list.append(Appliance("611",  0, False, 10, -1, 0, "", oshosts))

   list.append(Appliance("710",  0, False, 10, -1, 0, "", oshosts))
   list.append(Appliance("711",  0, False, 10, -1, 0, "", oshosts))
   list.append(Appliance("712",  0, False, 10, -1, 0, "", oshosts, 4, 8 ))
   list.append(Appliance("713",  0, False, 10, -1, 0, "", oshosts, 8, 12))
   list.append(Appliance("812",  0, False,  5, -1, 0, "", oshosts, 8, 16))
   list.append(Appliance("813",  0, False,  5, -1, 0, "", oshosts, 8, 16))

   #segs =assetTag.split("-")
   #model=segs[0]
   #if int(segs[1]) < 600:
   list.append(Appliance("713S",  0, False, 10, -1, 0, "", oshosts, 8, 12))
   list.append(Appliance("714S",  0, False, 10, -1, 0, "", oshosts, 8, 16))
   list.append(Appliance("814S",  0, False,  5, -1, 0, "", oshosts, 8, 16))
   list.append(Appliance("816S",  0, False,  5, -1, 0, "", oshosts, 8, 16))
         


         
   oshosts = ["host1", "host2"]
   list.append(Appliance("621",  8, False,  1, 6,  256, "3ware", oshosts))
   list.append(Appliance("631", 12, False,  1, 6,  256, "3ware", oshosts))

   list.append(Appliance("720",  6, False,  1, 6,  256, "3ware", oshosts)) # 6 drive as default
   list.append(Appliance("721",  8, False,  1, 6,  256, "3ware", oshosts))
   list.append(Appliance("722",  8, False,  1, 6,  256, "3ware", oshosts))
   list.append(Appliance("723",  8, False,  1, 6,  256, "3ware", oshosts))
   list.append(Appliance("730", 12, False,  1, 6,  256, "3ware", oshosts))
   list.append(Appliance("731", 12, False,  1, 6,  256, "3ware", oshosts))
   list.append(Appliance("732", 12, False,  1, 6,  256, "3ware", oshosts))
   list.append(Appliance("733", 12, False,  1, 6,  256, "3ware", oshosts))

   controller = "3ware"
   stripeSize = 256
   if "822" in assetTag or "823" in assetTag:
      # 833-100 06:00.0 RAID bus controller: 3ware Inc 9650SE SATA-II RAID PCIe (rev 01)
      # 823-100 01:00.0 RAID bus controller: 3ware Inc 9650SE SATA-II RAID PCIe (rev 01)
      # 823-300 01:00.0 RAID bus controller: LSI Logic / Symbios Logic MegaRAID SAS 2108 [Liberator] (rev 05)
      # 943     06:00.0 RAID bus controller: LSI Logic / Symbios Logic MegaRAID SAS 2108 [Liberator] (rev 05)
      # 833-200 (300) 08:00.0 RAID bus controller: 3ware Inc 9750 SAS2/SATA-II RAID PCIe (rev 05)
      
      import commands
      if "MegaRAID SAS" in  commands.getoutput("/sbin/lspci | grep 'RAID bus controller'"): #no need of .splitlines():
         controller = "LSI"
         stripeSize = 1024

   list.append(Appliance("822",  8, False,  1, 6,  stripeSize, controller, oshosts, 8, 31))
   list.append(Appliance("823",  8, False,  1, 6,  stripeSize, controller, oshosts, 8, 31))
         
   list.append(Appliance("832", 12, False,  1, 6,  256, "3ware", oshosts))
   list.append(Appliance("923", 12, False,  1, 6,  256, "3ware", oshosts))
   
   if "833" in assetTag:
      import commands
      if "3ware Inc 9750" in  commands.getoutput("/sbin/lspci | grep 'RAID bus controller'"): #no need of .splitlines():
         controller = "3ware_9750"

   list.append(Appliance("833", 12, False,  1, 6,  256, controller, oshosts))

   list.append(Appliance("824",  8, False,  1, 6,  1024, "LSI", oshosts))
   list.append(Appliance("943", 36, False,  1, 60, 1024, "LSI", oshosts, 32, 252, True))  # DBonHWR  resolve duplicate

   ################### 2014 NewGen in Production
   list.append(Appliance("823S",  8, False,  1,  6, stripeSize, controller, [],  8,  31, True))  # DBonHWR   resolve duplicate
   list.append(Appliance("824S",  8, False,  1,  6, 1024,       "LSI",      [], 24,  62, True))  # DBonHWR   resolve duplicate
   list.append(Appliance("933S", 14, False,  1,  6, 1024,       "LSI",      [], 24,  62, True, True))  # DBonHWR  resolve duplicate
   list.append(Appliance("936S", 16, False,  1, 60, 1024,       "LSI",      [], 24, 252, True))  # DBonHWR  resolve duplicate
   list.append(Appliance("943S", 36, False,  1, 60, 1024,       "LSI",      [], 32, 252, True, False, True))  # DBonHWR(resolve duplicate), OSDriveFrontBay, FlipOrder front and back
   list.append(Appliance("944S", 34, False,  1, 60, 1024,       "LSI",      [], 32, 252, True, True , True))  # DBonHWR(resolve duplicate), OSDriveFrontBay, FlipOrder front and back
   list.append(Appliance("946S", 34, False,  1, 60, 1024,       "LSI",      [], 32, 252, True, True , True))  # DBonHWR(resolve duplicate), OSDriveFrontBay, FlipOrder front and back

   #################### 2013 NewGen Prototype which didn't fly
   list.append(Appliance("2734E", 16, False,  1, 6, 1024, "LSI", oshosts))
   list.append(Appliance("323",   12, False,  1, 6, 1024, "LSI", oshosts))
   list.append(Appliance("434EX", 16, False,  1, 6, 1024, "LSI", oshosts, 0,0,True))
   list.append(Appliance("434",   16, False,  1, 6, 1024, "LSI", oshosts, 0,0,True))

   if doPrint:
      for aDevice in list:
         aDevice.printout()

   return list
