import os,sys
abs_path = os.path.abspath(sys.argv[0])
basename = os.path.basename(sys.argv[0])
dirname = abs_path.replace(basename, "")
if not "%s/diskmon/lib" % dirname in sys.path:
   sys.path.append("%s/diskmon/lib" % dirname) # always with regard to parent script
if not "/usr/bp/lib/monitoring" in sys.path:
   sys.path.append("/usr/bp/lib/monitoring")

from util       import *
_max_length_line = 80

#################class Appliance ##########################

def CheckDPU():

   if CONFIG.quick: return

   checks = []
   checks.append(Checklist("Database running", "warning", "",                                            not (CONFIG.dbON or CONFIG.dbVacuum), "False"))
   if not CONFIG.dbVacuum and CONFIG.dbON:
      lines =get_printout("ls /backups")
      if len(lines):
         IOcheck =lines[0]
         if "Input/output error" in IOcheck:
            print "ERROR: >>> %s" %IOcheck
         else:    
            checks.append(Checklist("Tasker running",   "exist",   "/usr/bp/bin/dispatch status 2>&1 | grep PID", False,           "False"))

   for check in checks:
      if not check.okay:
         print check

   return


class Checklist:
   """Holding partition information from smartctl"""
   def __init__(self, name, method, command, condition, reference):
      self.name = name
      self.method = method
      self.condition =condition
      self.reference = reference
      self.message = ''
      self.debugMessage = ''
      if method == "warning":
         self.message = warning_message(condition, name, reference)
         self.debugMessage = condition_message(condition, name)
      if method == "exist":
         self.message = check_exist(command, name)

      self.okay = True
      if len(self.message):
         self.okay = False
         
      return
   def __repr__(self):
      return "%s" % self.message




def does_exist(command):
    command += " | wc -l"
    theWord = get_first_word(command)
    if int(theWord) > 0:
        return True
    else:
        return False

def check_exist(command, message):
    message += " "
    for i in range(0,_max_length_line-len(message)):
        message += "."
    message += " "
    if not does_exist(command):
        return "%s[%s]" %(message, red(" False "))
    else:
       return ""

def warning_message(condition, message0, message1=""):
    for i in range(0,_max_length_line-len(message0)):
        message0 += "."
    if len(message1)==0:
        if condition:
            message0 += " [ %s ]" % red("True")
        else:
            message0 = ""
    else:
        if condition:
            message0 += " [ %s ]" % red(message1)
        else:
            message0 = ""

    return message0

def condition_message(condition, message0, message1=""):
    message0 += " "
    for i in range(0,_max_length_line-len(message0)):
        message0 += "."
    if len(message1)==0:
        if condition:
            message0 += " [ %s ]" % green("True")
        else:
            message0 += " [ %s ]" % red("False")
    else:
        if condition:
            message0 += " [ %s ]" % green(message1)
        else:
            message0 += " [ %s ]" % red(message1)
        
    return message0
