import os,sys   
abs_path = os.path.abspath(sys.argv[0])
basename = os.path.basename(sys.argv[0])
dirname = abs_path.replace(basename, "")
if not "%s/diskmon/lib" % dirname in sys.path:
   sys.path.append("%s/diskmon/lib" % dirname) # always with regard to parent script
if not "/usr/bp/lib/monitoring" in sys.path:
   sys.path.append("/usr/bp/lib/monitoring")
from config    import *
from disk      import *

##########################
def dailySMARTLOG(disks):

   files = get_printout("/bin/ls %s/*smart 2>&1 | grep -v 'No such'" % CONFIG.directory_paths[CONFIG.ibase])
   
   for disk in disks:
      if disk.model.index == 255 : continue
      (model, sn) = (disk.smart.modelName, disk.smart.serialNumber)
      filename = model + "." + sn
      if isinstance(disk, Disk_OS): 
         if disk.archive:
            filename = filename + ".arch"
            
      filename =filename + ".smart"
      filename =filename.replace(" ", "\ ")  # for space in model name
      fullFilename    = CONFIG.directory_paths[CONFIG.ibase] + "/" + filename
      fullFilenameOld = CONFIG.directory_paths[CONFIG.iretired] + "/" + filename
 
      for i in range(len(files)):  # pop it out of list
         if filename in files[i]:
            files.pop(i)
            break

      if not os.path.exists(fullFilename) and os.path.exists(fullFilenameOld):  # assuming that always non-zero filesize
         os.system("mv '%s' '%s'" % (fullFilenameOld, fullFilename))

      ###### logging part ######
      os.system("echo %s >> %s" % (disk.speclog, fullFilename))    
         
   for theFile in files:
      words = theFile.split("/")
      command="mv '%s' '%s/%s'" % (theFile, CONFIG.directory_paths[CONFIG.iretired], words[len(words)-1])
      os.system(command)

   return

##########################
def postDocumentation(disks):   

   files = get_printout("/bin/ls %s/*dat 2>&1 | grep -v 'No such file'" % CONFIG.directory_paths[CONFIG.ibase])
   
   for disk in disks:
      if disk.model.index == 255 : continue
      model = disk.smart.modelName
      sn    = disk.smart.serialNumber

      filename = model + "." + sn
      if isinstance(disk, Disk_OS): 
         if disk.archive:
            filename = filename + ".arch"
            
      filename =filename + ".dat"
      filename =filename.replace(" ", "\ ")  # for space in model name
      #fnames = [value for value in fnames if value != filename] # remove...
      fullFilename = CONFIG.directory_paths[CONFIG.ibase] + "/" + filename
      fullFilenameOld = CONFIG.directory_paths[CONFIG.iretired] + "/" + filename
 
      for i in range(len(files)):
         if filename in files[i]:
            files.pop(i)
            break
      
      if (not os.path.exists(fullFilename) and not os.path.exists(fullFilenameOld)):  
         log_disk_attribute(disk, fullFilename, 'w')
      elif os.path.exists(fullFilename) and os.path.getsize(fullFilename)==0:   
         log_disk_attribute(disk, fullFilename, 'w')
      else:
         if not os.path.exists(fullFilename) and os.path.exists(fullFilenameOld):  # assuming that always non-zero filesize
            os.system("mv '%s' '%s'" % (fullFilenameOld, fullFilename))

         if is_major_change(disk, fullFilename):
            log_disk_attribute(disk, fullFilename, 'a')
         else:   
            update_disk_attribute(disk, fullFilename)

   for theFile in files:
      words = theFile.split("/")
      os.system("mv '%s' '%s/%s'" % (theFile, CONFIG.directory_paths[CONFIG.iretired], words[len(words)-1]))


   ######################## ATA ERROR LOG ##########################   
   files = get_printout("/bin/ls %s/*ataerror 2>&1 | grep -v 'No such'" % CONFIG.directory_paths[CONFIG.ibase])

   for disk in disks:
      if disk.model.index == 255 : continue
      model = disk.smart.modelName
      sn    = disk.smart.serialNumber

      filename = model + "." + sn
      if isinstance(disk, Disk_OS): 
         if disk.archive:
            filename = filename + ".arch.ataerror"
            
      filename =filename + ".dat.ataerror"
      filename =filename.replace(" ", "\ ")  # for space in model name
      #fnames = [value for value in fnames if value != filename] # remove...
      fullFilename = CONFIG.directory_paths[CONFIG.ibase] + "/" + filename
      fullFilenameOld = CONFIG.directory_paths[CONFIG.iretired] + "/" + filename

      for i in range(len(files)):
         if filename in files[i]:
            files.pop(i)
            break
      
      if (not os.path.exists(fullFilename) and not os.path.exists(fullFilenameOld)):  
         log_disk_ataerrors(disk, fullFilename, 'w')
      elif os.path.exists(fullFilename) and os.path.getsize(fullFilename)==0:   
         log_disk_ataerrors(disk, fullFilename, 'w')
      else:         
         if not os.path.exists(fullFilename) and os.path.exists(fullFilenameOld):  # assuming that always non-zero filesize
            os.system("mv '%s' '%s'" % (fullFilenameOld, fullFilename))

         new_ataerror_idx = is_major_ataerror_change(disk, fullFilename)
         if new_ataerror_idx:  # return value will be zero if there is no update.
            log_disk_ataerrors(disk, fullFilename, 'a', new_ataerror_idx)

   for theFile in files:
      words = theFile.split("/")
      command="mv '%s' '%s/%s'" % (theFile, CONFIG.directory_paths[CONFIG.iretired], words[len(words)-1])
      os.system(command)

   #moving obsolete drive file to retired
   #fnames = [value for value in fnames if not "arch" in value] # remove...
   #for fname in fnames:
   #   command = "mv %s/" % CONFIG.directory_paths[CONFIG.ibase] + "%s " % fname + "%s/" % CONFIG.directory_paths[CONFIG.iretired] + "%s" %fname
   #   if CONFIG.debug: print command
   #   os.system(command)
   #import time
   #   endTime = time.time();   
   #   print t.timeit(1), endTime - startTime

###################
def review_output_files():

   dpu = DPU(1) # getting sn and model 
   printouts = []
   for fname in os.listdir(CONFIG.directory_paths[CONFIG.ibase]):
      if not "dat" in fname: continue

      isArchive = False
      if "arch" in fname:
         isArchive = True

      isOn = False
      for disk in dpu.disks:
         ref_fname = disk.smart.modelName + "." + disk.smart.serialNumber
         ref_fname = ref_fname.replace(" ", "\ ")
         if ref_fname in fname:
            isOn = True
            break

      for line in get_printout("/usr/bin/tail -1 %s" % (CONFIG.directory_paths[CONFIG.ibase] + "/" + fname)):
         words = line.split()
         if isArchive:
            if isOn:
               printouts.append( "%12s ARCH_ON_" %words[0] + "%50s" % fname + ":     %s" %line )
            else:   
               printouts.append( "%12s ARCH_OFF" %words[0] + "%50s" % fname + ":     %s" %line )
         else:   
            printouts.append( "%12s         " %words[0] + "%50s" % fname + ":     %s" %line )

   for out in sorted(printouts):
      print out[13:]

   return

#################
def is_major_ataerror_change(disk, fullFilename):
   isMajorChange = False

   lines = get_printout("/usr/bin/tail -1 %s " % fullFilename)
   if not len(lines): return 0
   words_old = lines[0].split()
   lastIdx =int(words_old[1])
   
   for diskerr in disk.diskErrors:
      idx = diskerr.Id
      if idx>lastIdx:
         return idx
      
   return 0

def log_disk_ataerrors(disk, fullFilename, option, new_ataerror_idx=0):
   f = open(fullFilename, option)
   
   for diskerr in disk.diskErrors:
      if option=="a" and diskerr.Id < new_ataerror_idx: continue
      if diskerr.Id ==0 : continue
      sentence = "# %4d  @ %5d H  %3s  %s\n" % (diskerr.Id, diskerr.Hour, diskerr.Type, diskerr.Abbr)
      f.write(sentence)
   
   f.close()

   return

#####
def is_major_change(disk, fullFilename):
   Device                  = disk.device + disk.suffix
   Power_On_Hours          = "%d" % disk.smart.hours
   Current_Pending_Sector  = "%d" % disk.smart.pending
   Offline_Uncorrectable   = "%d" % disk.smart.uncorr
   Reallocated_Sector_Ct   = "%d" % disk.smart.realloc
   Temperature_Celsius     = "%d" % disk.smart.tempert

   isMajorChange = False
   lines = get_printout("/usr/bin/tail -1 %s " % fullFilename)
   if not len(lines): return isMajorChange
   words_old = lines[0].split()

   Device_old                  = words_old[0]
   FirstPower_On_Hours_old     = words_old[1]
   LastPower_On_Hours_old      = words_old[2]
   Current_Pending_Sector_old  = words_old[3]
   Offline_Uncorrectable_old   = words_old[4]
   Reallocated_Sector_Ct_old   = words_old[5]
   if len(words_old) > 6:
      Temperature_Celsius_old     = words_old[6]
   else:
      Temperature_Celsius_old     = "0"

   if Device_old != Device:
      isMajorChange = True
      if CONFIG.debug: print Device_old + " >>> " + Device
   if Current_Pending_Sector != Current_Pending_Sector_old:
      isMajorChange = True
      if CONFIG.debug: print Current_Pending_Sector_old + " >>> " + Current_Pending_Sector
   if Offline_Uncorrectable  != Offline_Uncorrectable_old:   
      isMajorChange = True
      if CONFIG.debug: print Offline_Uncorrectable_old + " >>> " + Offline_Uncorrectable
   if Reallocated_Sector_Ct  != Reallocated_Sector_Ct_old:
      isMajorChange = True
      if CONFIG.debug: print Reallocated_Sector_Ct_old + " >>> " + Reallocated_Sector_Ct
      #if Temperature_Celsius    !=  Temperature_Celsius_old:
      #isMajorChange = True
      #if CONFIG.debug: print Temperature_Celsius_old + " >>> " + Temperature_Celsius
   return isMajorChange   
      
#########################
def update_disk_attribute(disk, fullFilename):
   lastLine = get_printout("/usr/bin/tail -1 %s " % fullFilename)[0]
   f = open(fullFilename, 'r')

   newFilename = fullFilename + ".temp"
   f2 = open(newFilename, 'w')

   for line in f:
      if lastLine.strip() == line.strip():
         lastWords = lastLine.strip().split()
         Power_On_Hours_Started  = lastWords[1]

         Device                  = disk.device + disk.suffix
         Power_On_Hours          = "%d" % disk.smart.hours
         Current_Pending_Sector  = "%d" % disk.smart.pending
         Offline_Uncorrectable   = "%d" % disk.smart.uncorr
         Reallocated_Sector_Ct   = "%d" % disk.smart.realloc
         Temperature_Celsius     = "%d" % disk.smart.tempert

         sentence = "%12s" % Device + "   %4d" % int(Power_On_Hours_Started) + "   %4d" % int(Power_On_Hours) \
                    + "  %5d" % int(Current_Pending_Sector) + " %5d" % int(Offline_Uncorrectable) \
                    + "  %8d" % int(Reallocated_Sector_Ct) + "  %3d" % int(Temperature_Celsius) +"\n"

         f2.write(sentence)
      else:
         f2.write(line)
   f2.close()         

   if os.path.exists(newFilename):
      command ="mv '%s' '%s'" % (newFilename, fullFilename)
      os.system(command)
   return

#########################
def log_disk_attribute(disk, fullFilename, option):

   Device                  = disk.device + disk.suffix
   Power_On_Hours          = "%d" % disk.smart.hours
   Current_Pending_Sector  = "%d" % disk.smart.pending
   Offline_Uncorrectable   = "%d" % disk.smart.uncorr
   Reallocated_Sector_Ct   = "%d" % disk.smart.realloc
   Temperature_Celsius     = "%d" % disk.smart.tempert
   
   f = open(fullFilename, option)
   
   sentence = "%12s" % Device + "   %4d" % int(Power_On_Hours) + "   %4d" % int(Power_On_Hours) \
              + "  %5d" % int(Current_Pending_Sector) + " %5d" % int(Offline_Uncorrectable) \
              + "  %8d" % int(Reallocated_Sector_Ct)  + "  %3d" % int(Temperature_Celsius) + "\n"
   
   f.write(sentence)
   
   f.close()
   return
