import os,sys
abs_path = os.path.abspath(sys.argv[0])
basename = os.path.basename(sys.argv[0])
dirname = abs_path.replace(basename, "")
if not "%s/diskmon/lib" % dirname in sys.path:
   sys.path.append("%s/diskmon/lib" % dirname) # always with regard to parent script
if not "/usr/bp/lib/monitoring" in sys.path:
   sys.path.append("/usr/bp/lib/monitoring")
from util     import *


def showMessage(diskType, status="", braket="", arrayNo=-9, rowNo=-9, extra=""):
    if CONFIG.selfhealing: return
    if '?' in extra:
       print "%s Either CacheCade or FlashCache SSD drive has an issue" % red('[ALERT]')
       return
    
    if diskType == 'OS':
        for case in switch(status):
            if case("RBLD"):
                print "[INFO] Rebuild in progress"
                print "        ==> Please, check /proc/mdstat to see if recovery is repeated"
                print "        ==> Useful commands : cat /proc/mdstat"
                break
            if case('FS'):
                print bcolors.RED + "[ALERT]" + bcolors.ENDC + " Degraded due to drive time sync "
                print "        ==> Please, check /proc/mdstat and initiate rebuild raid if needed"
                print "        ==> Useful commands : cat /proc/mdstat"
                print "                              mdadm --add /dev/md99 /dev/sdX99  # replace 99 with appropriate number"
                break
            if case('SMT'):
                print bcolors.RED + "[ALERT]" + bcolors.ENDC + " Disk with SMART concerns "
                print "        ==> Some disk has either pending sector(s) or too many reallocated sectors or high seek error rate"
                print "        ==> Please, check the table if there is -*- or -x- or -s-" 
                print "        ==> To fix pending sector, please start manual check ONLY when no degrade drive exist: "
                print "        ==>      # echo check > /sys/block/mdX/md/sync_action"
                print "        ==> To locate the drive: run the following command to light blinking 30 times every second"
                print "                                 # /usr/bp/bin/rebuild_disk --locate /dev/sdX"
                #                print "                                 # for i in {1..15}; do %s -i /dev/sdX; sleep 1 ; done" % CONFIG.smartctl_Path
                break
            if case():
                break

    elif diskType == 'LSI':
        for case in switch(status):
            if case('DD'):
                print "%s Mechanically dead drive found and marked as [--:--] (unless it's missing)" % red('[ALERT]')
                print "        ==> Please, replace the drive asap through warranty request"
                print "        ==> Useful command:   MegaCli64 -adpsetprop alarmsilence -a0 -NoLog   # to make alarm silent temporarily" 
                break
            if case('F'):
                print "%s Degraded drive found and marked as -F- " % red('[ALERT]')
                print "        ==> Please, (1) Identify the drive location from the map (2) Take the drive out of the bay (3) Wait for 10 seconds (4) Reseat it"
                print "        ==>         (5) Wait for 2 minutes (6) Run this script again to check if -R- is shown instead of -F-. "
                print "        ==> Useful command:   MegaCli64 -adpsetprop alarmsilence -a0 -NoLog   # to make alarm silent temporarily" 
                print "        ==> To locate the drive: run the following command in one line to light blinking 15 times every second"
                print "                                 # for i in {1..15}; do %s -PdInfo -PhysDrv[99:99] -a0 -NoLog; sleep 1 ; done" % (CONFIG.MegaCli64_Path)
                break
            if case('FS'):   
                print "%s Drive with degraded drive found and marked as -FS " % red('[ALERT]')
                print "        ==> Please, rebuild the array with this drive drop"
                print "        ==> Useful command:   MegaCli64 -pdrbld -start -physdrv%s -a0 -NoLog    #to initiate rebuild process" % braket
                print "        ==>                   MegaCli64 -pdrbld -showprog -physdrv%s -a0 -NoLog #to see the rebuild progress" % braket
                print "        ==>                   MegaCli64 -pdinfo -physdrv%s -a0 -NoLog           #to see the detailed information regarding the drive" % braket
                print "        ==> Useful command:   MegaCli64 -adpsetprop alarmsilence -a0 -NoLog   # to make alarm silent temporarily" 
                break
            if case('UB'):   
                print "%s Drive with degraded drive (Unconfigured(bad)) found and marked as -UB " % red('[ALERT]')
                print "        ==> Useful command:   MegaCli64 -pdinfo -physdrv%s -a0 -NoLog                        # to make sure if it's Unconfigured(bad)" % braket
                print "        ==>                   MegaCli64 -pdmakegood -physdrv%s -a0 -NoLog                    # to change to Unconfigured-Good" % braket
                print "        ==>                   MegaCli64 -cfgforeign -scan -a0 -NoLog                         # to check if there is any foreign configuration drive"
                # There are 1 foreign configuration(s) on controller 0.
                print "        ==>                   MegaCli64 -cfgforeign -clear -a0 -NoLog                        # to clear if any foreign configuration drive exists"
                # Foreign configuration 0 is cleared on controller 0.
                #theWords =get_printout("%s -pdgetmissing -a0 -NoLog | grep Array -A 1 | tail -1" % CONFIG.MegaCli64_Path)[0].split()
                #arrayNo = int(theWords[1])
                #rowNo = int(theWords[2])
                print "        ==>                   MegaCli64 -pdgetmissing -a0 -NoLog                             # to see arrayN and rowN for missing pd"
                print "        ==>                   MegaCli64 -pdreplacemissing -physdrv%s -array%d -row%d -a0 -NoLog # make sure to replace \"N\" in -arrayN and -rowN with integer from the above command" % (braket,arrayNo,rowNo)
                print "        ==>                   MegaCli64 -pdrbld -start -physdrv%s -a0 -NoLog                 # to initiate rebuild process" % braket
                print "        ==>                   MegaCli64 -pdrbld -showprog -physdrv%s -a0 -NoLog              # to see the rebuild progress" % braket
                print "        ==> Useful command:   MegaCli64 -adpsetprop alarmsilence -a0 -NoLog   # to make alarm silent temporarily" 
                break
            if case('OFF'):
                print "%s Drive with degraded drive (offline) found and marked as -OFF " % red('[ALERT]')
                print "        ==> Useful command:   MegaCli64 -pdonline -physdrv%s -a0 -NoLog                      # to make sure if it's offline" % braket
                break
            if case('UG'):   
                print "%s Drive with degraded drive (Unconfigured(good)) found and marked as -UG " % red('[ALERT]')
                print "        ==> Useful command:   MegaCli64 -pdinfo -physdrv%s -a0 -NoLog                           # to make sure if it's Unconfigured(good)" % braket
                print "        ==>                   MegaCli64 -cfgforeign -scan -a0 -NoLog                            # to check if there is any foreign configuration drive"
                # There are 1 foreign configuration(s) on controller 0.
                print "        ==>                   MegaCli64 -cfgforeign -clear -a0 -NoLog                           # to clear if any foreign configuration drive exists"
                # Foreign configuration 0 is cleared on controller 0.
                print "        ==>                   MegaCli64 -pdgetmissing -a0 -NoLog                                # to see arrayN and rowN for missing pd"
                theWords =get_printout("%s -pdgetmissing -a0 -NoLog | grep Array -A 1 | tail -1" % CONFIG.MegaCli64_Path)[0].split()
                arrayNo = int(theWords[1])
                rowNo = int(theWords[2])
                print "        ==>                   MegaCli64 -pdreplacemissing -physdrv%s -array%d -row%d -a0 -NoLog # make sure to replace \"N\" in -arrayN and -rowN with integer from the above command" % (braket,arrayNo,rowNo)
                print "        ==>                   MegaCli64 -pdrbld -start -physdrv%s -a0 -NoLog                 # to initiate rebuild process" % braket
                print "        ==>                   MegaCli64 -pdrbld -showprog -physdrv%s -a0 -NoLog              # to see the rebuild progress" % braket
                print "        ==> Useful command:   MegaCli64 -adpsetprop alarmsilence -a0 -NoLog   # to make alarm silent temporarily" 
                break
            if case('SMTP'):
               if CONFIG.prStatus == "Active":
                  print "        ==> Patrol Read is ON and Active. Please, check the status of pending sectors later."
            if case('SMT'):
               print bcolors.RED + "[ALERT]" + bcolors.ENDC + " Disk with SMART concerns "
               print "        ==> Some disk has either pending sector(s) or too many reallocated sectors or high seek error rate"
               print "        ==> Please, check the table if there is -*- or -x- or -s-"
               print "        ==> To fix pending sector, please start manual patrol read scan ONLY when no degrade drive exist: "
               print "        ==>      # %s -AdpPR -Start -a0" % CONFIG.MegaCli64_Path
               print "        ==> To locate the drive: run the following command in one line to light blinking 15 times every second"
               print "                                 # for i in {1..15}; do %s -PdInfo -PhysDrv[99:99] -a0 -NoLog; sleep 1 ; done" % CONFIG.MegaCli64_Path
                   
               break
            if case():
                break
            
    elif diskType == '3ware':
        for case in switch(status):
            if case('F'): pass
            if case('EE'): pass
            if case('DE'): pass
            if case('CF'):  #Failed and No smart available
                print "%s Degraded drive found and marked as -%s- " % (status, red('[ALERT]'))
                print "        ==> SMART information cannot be accessed"
                print "        ==> Please, check the KB article or expert for further instruction"
                print "        ==> Useful command:      # tw_cli maint remove c9 p99"
                print "        ==>                      # tw_cli maint rescan"
                print "                                 # tw_cli maint rebuild c99 u99 p99"
                break
            if case('FS') : pass
            if case('EES'): pass
            if case('CFS'): pass
            if case('DES'): pass
            if case('DGS'):
                raidname = braket
                unitname = arrayNo
                portNo = rowNo
                print "%s Drive with degraded drive found and marked as -%s- " % (status, red('[ALERT]'))
                print "        ==> SMART information can be accessed so please decide the disk health based on it"
                print "        ==> If there are small amount of pending sectors, please try to get rid of them by remove/rebuild it before warranty replacement"
                print "        ==> Useful command: tw_cli info %s " % raidname
                print "        ==>                 tw_cli maint remove %s %s" % (raidname, portNo)  
                print "        ==>                 tw_cli maint rescan"
                print "        ==>                 tw_cli maint rebuild %s %s %s" % (raidname, unitname, portNo)  
            if case('SMT'):
               if "VERIFY" in CONFIG.tw_cli_Status:
                   print "        ==> VERIFY is ongoing. Please, check the status of pending sectors later."
               else:   
                  print bcolors.RED + "[ALERT]" + bcolors.ENDC + " Disk with SMART concerns "
                  print "        ==> Some disk has either pending sector(s) or too many reallocated sectors or high seek error rate"
                  print "        ==> Please, check the table if there is -*- or -x- or -s-" 
                  print "        ==> To fix pending sector, please start manual verify ONLY when no degrade drive exist: "
                  print "        ==>      # %s /cX/uY start verify" % CONFIG.tw_cliPath
                  print "        ==> To locate the drive: run the following command in one line to light blinking 15 times every second"
                  print "                                 # for i in {1..15}; do %s /c99/p99 show smart; sleep 1 ; done" % CONFIG.tw_cliPath
                  
               break
            if case():
               break

